from calendar import month_name
from fileinput import filename
from os import listdir
from os.path import join, dirname, realpath
from sqlalchemy import null
from werkzeug.utils import secure_filename
import os
from flask import Flask, request, Blueprint, jsonify, redirect, url_for,flash, render_template,session,json
import datetime
from datetime import timedelta,date,datetime
from flask import session, app
from .. import Cryptography,Auth,RouteGroup,Helper
from core.model.Users import Users
from core.model.Reference import Reference
# RemainderMailModel
from core.model.ReminderMailModel import ReminderMailModel
from core.model.MAttachmentType import MAttachmentType
from core.model.UserAttachments import UserAttachments
from core.model.UserWork import UserWork
from core.model.UserStatusLogs import UserStatusLogs
from core.model.Society import Society
from core.model.MembershipMailTemplates import MembershipMailTemplates
from core.library.email import EMAIL
from core.library.bravo import Bravo
import boto3, botocore
from collections import defaultdict
from botocore.exceptions import ClientError
import logging
from urllib.parse import unquote

app = Blueprint('reminder', __name__)

@app.route('/reminder_mail_v1',methods = ["GET", "POST"])
def ReminderMailV1():
	
	now              = datetime.now()
	dt_string        = now.strftime("%Y-%m-%d %H:%M:%S")
	dt_string_format = now.strftime("%Y-%m-%d")
	rejected_data    = ReminderMailModel().RejectedData(dt_string_format,None)
	hour             = now.hour
	minutes          = now.minute
# 	if rejected_data:
	if (hour == 9 and minutes > 45) or (hour == 10 and minutes < 23):
		if rejected_data :
				for row in rejected_data:
					societyData    = Society().getSociety(row['society_id'],row['society_key'])
					reminder_email_count  = row['reminder_email_count']
					user_status_log_id    = row['user_status_log_id']
					full_name             = row['prefix']+" "+row['full_name'] if row['prefix'] else row['full_name']
					email                 = row['email']
					created_at            = row['created_at']
					next_reminder_date    = row['next_reminder_date']
					year                  = created_at.year
					day                   = created_at.day
					month_name            = created_at.strftime("%B")
					date_1 = str(day)+" "+  month_name +" "+  str(year)
					if reminder_email_count :
						reminder_email_count = reminder_email_count+ 1
					else : 
						reminder_email_count = 0 +1
						
					if next_reminder_date :
						next_reminder_date = next_reminder_date +timedelta(days=3)
					else :
						next_reminder_date = now +timedelta(days=3)
						next_reminder_date = next_reminder_date.date()

					if reminder_email_count and reminder_email_count == 1 :
						data = {'reminder_email_count' : reminder_email_count,'reminder_one_send_at' : now,'updated_at' : now,'next_reminder_date':next_reminder_date}
					elif reminder_email_count and reminder_email_count == 2 :
						data = {'reminder_email_count' : reminder_email_count,'reminder_two_send_at' : now,'updated_at' : now,'next_reminder_date':next_reminder_date}
					else :
						data = {'reminder_email_count' : reminder_email_count,'reminder_three_send_at' : now,'updated_at' : now,'next_reminder_date':next_reminder_date}

					update_reminder_logs = ReminderMailModel().update_reminder_logs(data,user_status_log_id)


					reminderMailData = MembershipMailTemplates().get_mail_template(societyData['society_id'],"autoreminder_rejected_mail")
					sub_data        = {'full_name'    : full_name,'society_name' : societyData['society_intial'],'reminder_email_count':str(reminder_email_count)}
					subject         = Helper.merge_tags(reminderMailData.subject,sub_data)
					m_data          = {
						'mail_content'        : reminderMailData.mail_content,
						'full_name'           : full_name,
						'remarks'             : row['remarks'],
						'date_1'              : date_1,
						'societyData'         : societyData
					}  
					mail_content     = Helper.convert_html_for_mail_screen(m_data)
					html        = render_template('back_office/email/bo_mail_template.html',mail_content=mail_content,societyData=societyData,society_id=societyData['society_id'],society_key=societyData['society_key'])
					EMAIL.sendMail(subject,html,email,reminderMailData,societyData)
				return 'success for sending rejected reminder mail'
		else:
			
			return "Rejected data not exists."  

	else:
		return "Time not match"

# @app.route('/reminder_mail',methods = ["GET", "POST"])
# @app.route('/reminder_mail/<society_id>/<society_key>',methods = ["GET", "POST"])
# def ReminderMail(society_id=None,society_key=None):
#   society = None
#   msg = ""
#   if society_id and society_key:
#       society = Auth.checkSocietybyIdKey(society_id,society_key)

#   if society is None: 
#       society,msg = Auth.checkSociety()
#   if society:
#       society_id  = society['society_id']
#   update_data = {}
#   reminder_email_count = 0
#   now          = datetime.now()
#   dt_string    = now.strftime("%Y-%m-%d %H:%M:%S")
	

#   hour         = now.hour
#   minutes      = now.minute
#   reminderMailData = MembershipMailTemplates().get_mail_template(society_id,"autoreminder_rejected_mail")
#   dt_string_format = now.strftime("%Y-%m-%d")
#   if (hour == 9 and minutes > 45) or (hour == 10 and minutes < 23):
#       rejected_data  = ReminderMailModel().RejectedData(dt_string_format,society_id)
#       if rejected_data :
#           for index,value in enumerate(rejected_data):
#               reminder_email_count  = value['reminder_email_count']
#               prefix                = value['prefix']
#               name                  = value['full_name']
#               status_id             = value['status_id']
#               email                 = value['email']
#               created_at            = value['created_at']
#               remarks               = value['remarks']
#               user_status_log_id    = value['user_status_log_id']
#               next_reminder_date    = value['next_reminder_date']
#               year                  = created_at.year
#               day                   = created_at.day
#               month_name            = created_at.strftime("%B")
#               full_name             = prefix+" "+name if prefix else name
#               date_1 = str(day)+" "+  month_name +" "+  str(year)
				
#               if reminder_email_count :
#                   reminder_email_count = reminder_email_count+ 1
#               else : 
#                   reminder_email_count = 0 +1
					
#               if next_reminder_date :
#                   next_reminder_date = next_reminder_date +timedelta(days=3)
#               else :
#                   next_reminder_date = now +timedelta(days=3)
#                   next_reminder_date = next_reminder_date.date()

	
#               if reminder_email_count and reminder_email_count == 1 :
#                   data = {'reminder_email_count' : reminder_email_count,'reminder_one_send_at' : now,'updated_at' : now,'next_reminder_date':next_reminder_date}
#               elif reminder_email_count and reminder_email_count == 2 :
#                   data = {'reminder_email_count' : reminder_email_count,'reminder_two_send_at' : now,'updated_at' : now,'next_reminder_date':next_reminder_date}
#               else :
#                   data = {'reminder_email_count' : reminder_email_count,'reminder_three_send_at' : now,'updated_at' : now,'next_reminder_date':next_reminder_date}

#               update_reminder_logs = ReminderMailModel().update_reminder_logs(data,user_status_log_id)    
#               ReminderRejectedMail(full_name,reminder_email_count,remarks,email,date_1,reminderMailData)
					
#           return "success"
#       else:
			
#           return "Rejected data not exists."  
#   else :
		
#       return dt_string +  "- Time not match"          

# def ReminderRejectedMail(full_name,reminder_email_count,remarks,email,date_1,reminderMailData):
#   societyData     = Auth.getSociety()
#   sub_data        = {'full_name'    : full_name,'society_name' : societyData['society_intial'],'reminder_email_count':str(reminder_email_count)}
#   subject         = Helper.merge_tags(reminderMailData.subject,sub_data)
#   # subject         = "Reminder "+str(reminder_email_count)+" : "+full_name +", Your  " +Auth.getSociety()['society_name']+ " membership application is NOT APPROVED" 
#   m_data          = {
#       'mail_content'        : reminderMailData.mail_content,
#       'full_name'           : full_name,
#       'remarks'             : remarks,
#       'date_1'              : date_1,
#       'societyData'         : societyData
#   }  
#   mail_content     = Helper.convert_html_for_mail_screen(m_data)
#   html             = render_template('back_office/email/bo_mail_template.html',mail_content=mail_content)
#   EMAIL.sendMail(subject,html,email,reminderMailData)
#   return "success"  

@app.route('/mem_daily_count_mail',methods = ["GET", "POST"])
def MemDailyCountMail():
	send_manual    = request.values.get('send_manual',None)
	society = None
	msg     = ""
	now          = datetime.now()
	dt_strings   = now.strftime("%Y-%m-%d %H:%M:%S")
	hour         = now.hour
	minutes      = now.minute
	dt_string      = datetime.now() - timedelta(days=1)
	dt             = dt_string.strftime("%Y-%m-%d")
	if send_manual and int(send_manual) == 1 :
		return AllSocietyMembershipReportSendMail(dt)
	else :
		if (hour == 9 and minutes > 45) or (hour == 10 and minutes < 23):
			AllSocietyMembershipReportSendMail(dt)
			return 'success'
		else :
			return dt_strings +  "- Time not match. Mail will send at 10 AM in Every morning"   
	return ("mail sent ")

def AllSocietyMembershipReportSendMail(dt):

	users          = Society().get_emails_data()
	societies_data = Society().getAllSociety()
	socities       = {}
	for society in societies_data:
		socities[society['society_id']] = society
   
	dt_string      = datetime.now() - timedelta(days=1)
	current_dt     = dt_string.strftime("%d-%m-%Y")
	now            = datetime.now()
	now_datetime   = now.strftime("%d-%m-%Y")


	in_society_id  = []
	sender_mail = []
	if users :
		for row in users:
			html        = []
			email       = ""
			full_name   = ""
			mobile      = ""
			email       = row['email']
			full_name   = row['full_name']
			str_society_id = row['society_id']
			lst_society_id = str_society_id.split(",")
			html.clear()
			for x in lst_society_id:
				soc = socities.get(int(x),None)
				societyData    = Society().getSociety(soc['society_id'],soc['society_key'])
				if soc:
					countData  = Users().usp_get_mem_daily_count(x,dt)

					html_data       = render_template('back_office/email/daily_count_mail.html',countData=countData,current_dt=current_dt,society=societyData,now_datetime=now_datetime)
					# html_data    = render_template('email/all_conference_dail_mail_count.html',previous_date =previous_date,reg_data = reg_data,conf=conf,date=dt_string,today_count=today_count,total_count=total_count,today_paid_amount=today_paid_amount,total_paid_amount=total_paid_amount,today_del_count=today_del_count,total_del_count=total_del_count) 
					htmls        = html_data.replace("\n", "")
					html.append(htmls)

			html_datas   = str(html).replace("['", " ").replace("']", " ").replace(",", "").replace("' '", "")
			html_tmp     = render_template('back_office/email/membership_report_mail_all.html',html=html_datas)

			MailData     = MembershipMailTemplates().get_mail_template(society['society_id'],"daily_count_mail")
			subject      = 'Membership Application Status'
			
			
			EMAIL.sendMail(subject,html_tmp,email,MailData,societyData)
			
			sender_mail.append(email) 
			# return html_tmp
		return jsonify(sender_mail) 
	else : 
		pass
		
@app.route('/mem_daily_count_mail_v1',methods = ["GET", "POST"])
def MemDailyCountMail_V1():
	send_manual = request.values.get('send_manual',None)
	society 	= None
	msg     	= ""
	now          = datetime.now()
	dt_strings   = now.strftime("%Y-%m-%d %H:%M:%S")
	hour         = now.hour
	minutes      = now.minute
	dt_string      = datetime.now() - timedelta(days=1)
	dt             = dt_string.strftime("%Y-%m-%d")
	if send_manual and int(send_manual) == 1 :
		return AllSocietyMembershipReportSendMail_v1(dt)
	else :
		if (hour == 6 and minutes == 30):
			return AllSocietyMembershipReportSendMail_v1(dt)
		else :
			return dt_strings +  "- Time not match. Mail will send at 10 AM in Every morning"   
	return ("mail sent ")



def AllSocietyMembershipReportSendMail_v1(dt):
	report_data    = Users().usp_get_mem_daily_count_v1(dt)
	daily_count    = report_data[0]
	users  		   = report_data[1]
	society_reports   = defaultdict(list)
	for i in daily_count:
		society_reports[i["society_id"]].append(i)
	
	for i in users:
		report = society_reports[i["society_id"]]
		if report :			
			if i["to_email"]:
				to_emails   = i["to_email"].split(",")
				# to_emails   = "sivabalan@numerotec.com"
			else:
				to_emails   = "priyavarthana@numerotec.com"
			if i["bcc_email"] and i["to_email"]:
				bcc_email   = i["bcc_email"].split(",")
				# bcc_email     = "priyavarthana@numerotec.com"
			else:
				bcc_email   =  [ 'priyavarthana@numerotec.com', 'sivabalan@numerotec.com', 'sridharan.r@numerotec.com']
			dt_string      = datetime.now() - timedelta(days=1)
			current_dt     = dt_string.strftime("%d-%m-%Y")
			now            = datetime.now()
			now_datetime   = datetime.now().strftime("%d-%m-%Y %I:%M %p")
			societyData    = Society().getSociety(i["society_id"],i["society_key"])		
			html_data      = render_template('back_office/email/daily_count_mail_v1.html',countData=report,current_dt=current_dt,society=societyData,now_datetime=now_datetime,users=i)
			MailData       = MembershipMailTemplates().get_mail_template(i['society_id'],"daily_count_mail")
			subject        = societyData['society_intial']+" - Membership Application Status on {}".format(now_datetime)
# 			return html_data
			EMAIL.dailcountsendMail_v2(subject,html_data,to_emails,bcc_email,MailData,societyData)
	return "success"
	
	
def AllSocietyMembershipReportSendMail_v2(dt):
	report_data    = Users().usp_get_mem_daily_count_v1(dt)
	daily_count    = report_data[0]
	users  		   = report_data[1]
	society_reports   = defaultdict(list)
	for i in daily_count:
		society_reports[i["society_id"]].append(i)
	
	for i in users:
		report = society_reports[i["society_id"]]
		if report :			
			if i["to_email"]:
				to_emails     = i["to_email"]
				# to_emails   = "sivabalan@numerotec.com"
			else:
				to_emails   = "priyavarthana@numerotec.com"
			if i["bcc_email"] or i["to_email"]:
				bcc_email   = i["bcc_email"]
				# bcc_email     = "priyavarthana@numerotec.com"
			else:
				bcc_email     = "priyavarthana@numerotec.com,sivabalan@numerotec.com"
			dt_string      = datetime.now() - timedelta(days=1)
			current_dt     = dt_string.strftime("%d-%m-%Y")
			now            = datetime.now()
			now_datetime   = datetime.now().strftime("%d-%m-%Y %I:%M %p")
			societyData    = Society().getSociety(i["society_id"],i["society_key"])		
			html_data      = render_template('back_office/email/daily_count_mail_v1.html',countData=report,current_dt=current_dt,society=societyData,now_datetime=now_datetime,users=i)
			MailData       = MembershipMailTemplates().get_mail_template(i['society_id'],"daily_count_mail")
			subject        = societyData['society_intial']+" - Membership Application Status on {}".format(now_datetime)
			# return html_data
			Bravo.sendbravoMail_v2(subject,html_data,to_emails,bcc_email,MailData,societyData)
	return "success"
	
	
@app.route('/update_kos_mem_tarrif',methods = ["GET", "POST"])
def UpdateKosMemTarriff():
	amount       = Helper.kos_tarrif
	now          = datetime.now()
	date         = now.day
	month        = now.month
	hour         = now.hour
	minutes      = now.minute
	if (date == 18 and month == 6 and hour == 12 and minutes == 00):
		society = Society().update_mem_tarrif(amount)
		return "updated the tarrif"
	else:
		return "time not match"
		
		
@app.route("/update_mem_schedule_tarrif", methods=["GET", "POST"])
def update_mem_schedule_tarrif():
	now = datetime.now()
	now = now.strftime('%Y-%m-%d %H:%M')
	now_datetime   = datetime.now().strftime("%d-%m-%Y %I:%M %p")
	extended_data = Society().get_update_mem_tarrif(now)
	if extended_data:
		for ext_data in extended_data:
			if ext_data['member_type_id'] == ext_data['schedule_member_type_id']:
				if str(ext_data['scheduled_on'].strftime('%Y-%m-%d %H:%M')) == now:
					msg = Society().update_schedule_mem_tarrif(now,ext_data['member_type_id'])
					# return "success"
				else:
					return "waiting to update"
			else:
				return "failed"
		if msg and msg == "success":
			data = Society().get_all_data(now)
			subject         = "Membership Tarrif changed on "+ now_datetime	
			to              = ["sai@numerotec.com","manjula@numerotec.com",'sridharan.r@numerotec.com','dp@numerotec.com',"sivabalan@numerotec.com",'priyavarthana@numerotec.com']
			html_data = render_template('back_office/email/membership_tarrif_change.html',data=data,now_datetime=now_datetime)
			EMAIL.SendMailChangeTarrif(subject,html_data,to)
			# return html_data
			return "success"
	return "no extended data"