from fileinput import filename
from os import listdir
from os.path import join, dirname, realpath
from sqlalchemy import null
from werkzeug.utils import secure_filename
import os
from flask import Flask, request, Blueprint, jsonify, redirect, url_for,flash, render_template,session,json,Response
import datetime
from datetime import timedelta,date,datetime
from flask import session, app
from .. import Cryptography,Auth,RouteGroup,Helper
from core.model.Users import Users
from core.model.UserQualification import UserQualification
from core.model.States import States
from core.model.Society import Society
from core.model.Countries import Countries
from core.model.ExportFilterCols import ExportFilterCols
from core.model.Reference import Reference
from core.model.MMemberType import MMemberType
from core.model.MWorkType import MWorkType
from core.model.MStatus import MStatus
from core.model.MAttachmentType import MAttachmentType
from core.model.MPaymentType import MPaymentType
from core.model.MembershipMailTemplates import MembershipMailTemplates
from core.model.UserAttachments import UserAttachments
from core.model.UserPayment import UserPayment
from core.model.UserPublication import Userpublication
from core.model.UserWork import UserWork
from core.model.UserStatusLogs import UserStatusLogs
from core.model.SocietyMapMemberType import SocietyMapMemberType
from core.library.email import EMAIL
import boto3, botocore
from botocore.exceptions import ClientError
import logging
import requests
from urllib.parse import unquote
import math
import urllib
import io
import csv
from io import StringIO
import string

app = Blueprint('adminmem', __name__)

@app.route('/admin', methods = ["GET","POST"])
def Admin():
	return render_template('admin_mem/admin_dashboard.html')



# Society Map Member Type ----starts.
@app.route('/society_map_membertype_index', methods = ["GET","POST"])
def SocietyMapMembertypeIndex():
	society_map_membertype = SocietyMapMemberType().get_society_map_membertype()
	return render_template('admin_mem/society_map_index.html',data=society_map_membertype)

@app.route('/add_society_map_membertype', methods = ["GET","POST"])
def AddSocietyMapMembertype():
	data={
	'created_at' : datetime.now()
	}
	society_map_membertype_data= SocietyMapMemberType().insert_society_map_membertype(data)
	smmt_id = society_map_membertype_data
	society_map_membertype = SocietyMapMemberType().get_society_map_membertype_id(smmt_id)
	return render_template('admin_mem/society_map_membertype.html',data=society_map_membertype)


@app.route('/society_map_membertype/<smmt_id>', methods = ["GET","POST"])
def SocietyMapMembertype(smmt_id):
	society_map_membertype = SocietyMapMemberType().get_society_map_membertype_id(smmt_id)
	return render_template('admin_mem/society_map_membertype.html',data=society_map_membertype,smmt_id=smmt_id)

@app.route('/post_society_map_membertype//<smmt_id>', methods = ["GET","POST"])
def PostSocietyMapMembertype(smmt_id):
	society_id   	 = request.form['society_id']
	member_type_id   = request.form['member_type_id']
	amount   		 = request.form['amount']
	display_name  	 = request.form['display_name']
	is_active 		 = request.values.get('is_active') or 0

	data={
		'society_id'	: society_id,
		'member_type_id': member_type_id,
		'amount'		: amount,
		'display_name'	: display_name,
		'is_active'		: is_active
	}
	SocietyMapMemberType().update_society_map_membertype(smmt_id,data)
	flash('updated successfully','successMsg')
	return redirect(url_for('adminmem.SocietyMapMembertype',smmt_id=smmt_id))
# Society Map Member Type ----ends.


# Mail Template ----starts.
@app.route("/mail_settings" , methods=['GET','POST'])
def MailSettings():
	return render_template('admin_mem/mail_template.html')

@app.route("/post_mail_template" , methods=['GET','POST'])
def PostMailTemplate():
	society_id 		= request.form['society_id']
	society_key 	= request.form['society_key']
	return redirect(url_for('adminmem.MailTemplateIndex',society_id=society_id,society_key=society_key))

@app.route("/add_mail_template/<society_id>/<society_key>" , methods=['GET','POST'])
def AddMailTemplate(society_id,society_key):
	data = {
	'society_id':society_id,
	'app_type_id':1
	}
	mailData=MembershipMailTemplates().insert_mail_template(data)
	return render_template('admin_mem/m_mail_template.html',society_id=society_id,society_key=society_key,mailData=mailData)

@app.route("/post_add_mail_template/<society_id>/<society_key>" , methods=['GET','POST'])
def PostAddMailTemplate(society_id,society_key):
	template_name   = request.form['template_name']
	sub_type        = request.form['sub_type']
	subject         = request.form['subject']
	mail_type       = request.form['mail_type']
	mail_content    = request.form['mail_content']
	is_active       = request.values.get('is_active') or 0
	is_backup       = request.values.get('is_backup') or 0
	data = {
	        'society_id'      : society_id,
	        'app_type_id'     : 1,
	        'template_name'   : template_name,
	        'subject_type'    : sub_type,
	        'subject'         : subject,
	        'mail_type'       : mail_type,
	        'mail_content'    : mail_content,
	        'is_active'       : is_active,
	        'updated_at'	  : datetime.now(),
	        'is_send_backup'  : is_backup
	}
	if template_name:
		check_mail_template=MembershipMailTemplates().check_mail_template(template_name,society_id)
		if check_mail_template:
			mail_template_id        = check_mail_template.mail_template_id
			MembershipMailTemplates().update_mail_template(mail_template_id,data)
			data ={'msg':'Updated Successfully',}			
		else:
			MembershipMailTemplates().insert_mail_template(data)
			data ={'msg':'Inserted Successfully'}
		return json.dumps(data)

@app.route("/mail_template_index/<society_id>/<society_key>" , methods=['GET','POST'])
def MailTemplateIndex(society_id,society_key):
	Auth.checkSocietybyIdKey(society_id,society_key)
	templateData  = MembershipMailTemplates().get_mail_template_name(society_id)
	return render_template('admin_mem/mail_index.html',templateData=templateData,society_id=society_id,society_key=society_key)

@app.route("/mail_template/<mail_template_id>/<society_id>/<society_key>" , methods=['GET','POST'])
def MailTemplate(mail_template_id,society_id,society_key):
	mailData = MembershipMailTemplates().get_mail_template(society_id,mail_template_id)
	is_preview = 0
	datas = render_template('back_office/email/bo_mail_template.html',mail_content=mailData.mail_content)
	return render_template('admin_mem/m_mail_template.html',society_id=society_id,society_key=society_key,mailData=mailData,datas=datas,is_preview=is_preview)


@app.route("/preview_mail/<society_id>/<society_key>" , methods=['GET','POST'])
def PreviewMail(society_id,society_key):
	sub_type     = request.values.get('sub_type')
	subject   	 = request.values.get('subject')
	datas 		 = request.values.get('mail_content')
	is_layout    = request.values.get('is_layout')
	if int(is_layout) == 1:
		datas = render_template('back_office/email/bo_mail_template.html',mail_content=datas)

	else:
		pass
	
	datas = {'sub_data':subject,'data':datas,"msg" : "successfully" ,"status" : 1}
	json_data = json.dumps(datas,default=str)
	return json_data

@app.route("/get_preview_mail/<mail_template_id>/<society_id>/<society_key>" , methods=['GET','POST'])
def getPreviewMail(mail_template_id,society_id,society_key):
	mailData = MembershipMailTemplates().get_mail_template(society_id,mail_template_id)
	print(mailData)
	is_preview = 1
	datas = render_template('back_office/email/bo_mail_template.html',mail_content=mailData.mail_content)
	return render_template('admin_mem/m_mail_template.html',society_id=society_id,society_key=society_key,mailData=mailData,datas=datas,is_preview=is_preview)

# Mail Template ----ends.