"""
Author : Priyavarthana
Date : 2022-04-21 09:50 AM
"""
from flask import Flask, request, Blueprint, jsonify, redirect, url_for,flash, render_template,session,json,Response
from sqlalchemy.sql.expression import insert
from sqlalchemy.sql.functions import user
from core.model.Society import Society
from core.model.Users import Users
from core.model.UserQualification import UserQualification
from core.model.UserTraining import UserTraining
from core.model.UserWork import UserWork
from core.model.UserPublication import Userpublication
from core.model.UserPayment import UserPayment
from core.model.UserAttachments import UserAttachments
from core.model.UserOthersociety import UserOthersociety
from core.model.Reference import Reference
from core.model.States import States
from core.model.Countries import Countries
from core.model.MWorkType import MWorkType
from core.model.MMemberType import MMemberType
from core.model.MPaymentType import MPaymentType
from core.model.UserStatusLogs import UserStatusLogs
from core.model.MAttachmentType import MAttachmentType
from core.model.MStatus import MStatus
from core.model.MSteps import MSteps
from core.model.Log import Log
from core.model.MembershipMailTemplates import MembershipMailTemplates
from random import randint
import datetime
from datetime import timedelta,date,datetime
from .. import Cryptography,Auth,Helper,RouteGroup,AppMessage,path_wkhtmltopdf,is_windows_os
from core.library.email import EMAIL
from flask import session, app
from os import listdir
from os.path import join, dirname, realpath
from werkzeug.utils import secure_filename
import os
from os import path
from PIL import Image
import io
import urllib.request
import math, random
import base64 
from urllib.parse import unquote
import boto3, botocore
from botocore.exceptions import ClientError
import logging
import requests
import flask
import pdfkit

app = Blueprint('member', __name__)

"""
Usage :for member entry step page

*  Step 1
* return html page for getting members email
* already member enter your email to login
"""

# Autologin for user dashboard
@app.route('/<int:society_id>/<string:society_key>/at/<user_uuid>/<timestamp>', methods = ["GET", "POST"])
@RouteGroup.society_required
def AutoLoginFromUserDashboard(society_id,society_key,user_uuid,timestamp):
	timestamp = round(int(timestamp[:-3]))
	timestamp = datetime.fromtimestamp(int(timestamp))
	if timestamp and (datetime.now() < timestamp):
		userData  = Users().get_autologin_data(user_uuid)
		user_id   = userData['user_id']
		society_id    = userData['society_id']
		society_key   = userData['society_key']
		if userData:
			Auth.checkSocietybyIdKey(society_id,society_key)
			bo_access = Users().check_bo_access(userData['email'],1,society_id,None)
			userData["is_admin"] =  bo_access["is_admin"]
			Auth.login(userData,society_id)
			encrypt_user_id  = Cryptography.encrypt(int(user_id))
			return redirect(url_for("member.Dashboard",user_id=encrypt_user_id,society_id=society_id,society_key=society_key))
		else:
			return redirect(url_for('member.getLogin',society_id=society_id,society_key=society_key))
	else:
		return redirect(url_for('member.getLogin',society_id=society_id,society_key=society_key))

# BoAutologin for user dashboard
@app.route('/<int:society_id>/<string:society_key>/admin/at/<user_uuid>/<timestamp>', methods = ["GET", "POST"])
@RouteGroup.society_required
def BoAutoLoginFromUserDashboard(society_id,society_key,user_uuid,timestamp):
	timestamp = round(int(timestamp[:-3]))
	timestamp = datetime.fromtimestamp(int(timestamp))
	if timestamp and (datetime.now() < timestamp):
		userData  = Users().get_autologin_data(user_uuid)
		user_id   = userData['user_id']
		society_id    = userData['society_id']
		society_key   = userData['society_key']
		if userData:
			Auth.checkSocietybyIdKey(society_id,society_key)
			bo_access = Users().check_bo_access(userData['email'],1,society_id,None)
			userData["is_admin"] =  bo_access["is_admin"]
			Auth.login(userData,society_id)
			encrypt_user_id  = Cryptography.encrypt(int(user_id))
			return redirect(url_for("backoffice.ApprovalPage",user_id=encrypt_user_id,society_id=society_id,society_key=society_key))
		else:
			return redirect(url_for('backoffice.getLogin',society_id=society_id,society_key=society_key))
	else:
		return redirect(url_for('backoffice.getLogin',society_id=society_id,society_key=society_key))


@app.route('/', methods = ["GET"])
def Home():
	app_host = request.host
	society      = Society().setSociety(app_host)
	if society:
		return redirect (url_for('member.getLogin',society_id=society['society_id'],society_key=society['society_key']))
	else:
		session.pop('_flashes', None)
		flash("Invalid URL","errorMsg")
		return render_template('memberapp_users/display_msg.html')  

@app.route('/<int:society_id>/<string:society_key>', methods = ["GET"])
@RouteGroup.society_required
def homeloginsociety(society_id,society_key):
	if Auth.check(society_id):
		user_id          = Auth.user(society_id)['user_id']
		encrypt_user_id  = Cryptography.encrypt(int(user_id))
		return redirect(url_for('member.Dashboard',user_id=encrypt_user_id,society_id=society_id,society_key=society_key))
	else:
		return redirect (url_for('member.getLogin',society_id=society_id,society_key=society_key))

@app.route('/login/<int:society_id>/<string:society_key>', methods = ["GET"])
@RouteGroup.society_required
def getLogin(society_id,society_key):
	if Auth.check(society_id):
		user_id          = Auth.user(society_id)['user_id']
		encrypt_user_id  = Cryptography.encrypt(int(user_id))
		return redirect(url_for('member.Dashboard',user_id=encrypt_user_id,society_id=society_id,society_key=society_key))
	else:
		societyData = Auth.getSociety(society_id)
		index_content = societyData['index_content']
		index_data = {
				
				'support_mail'  : societyData['e_support_mail'],
			}
		if index_content:
			soiety_index_content    = Helper.merge_tags(index_content,index_data)
		else:
			soiety_index_content    = None
		return render_template('memberapp_users/login.html',society_id=society_id,society_key=society_key,societyData=societyData,soiety_index_content=soiety_index_content)

@app.route('/login/<int:society_id>/<string:society_key>', methods = ["POST"])
def postLogin(society_id,society_key):
	email           = request.form['email']
	userData        = Users().check_email(email,society_id)
	if userData is None: # if no email id then we will insert new users and send otp 
		data        = {'email' :email,'society_id':society_id,'created_at'  : datetime.now(),'updated_at'  : datetime.now()}
		user_id     = Users().insert_member(data)
		# save system logs start
		system_data   = request.headers.get("user-agent")
		ip_add        = request.headers.get('X-Forwarded-For', request.remote_addr)
		route_name = request.path
		route_name = route_name[1:]
		app_url_1  = request.host_url
		if "https" in app_url_1:
			pass
		else:
			app_url_1 = app_url_1.replace("http","https")   

		app_url = app_url_1+route_name

		params        = "system_log?society_id="+str(society_id)+"&email="+email+"&app_type=MEMBERSHIP&app_url="+app_url+"&ip_add="+ip_add+"&system_data="+system_data
		api_url      = "https://conference.numerotech.com/" +params
		result = requests.get(api_url)
		res = result.text
		# res = json.loads(res)
		# end
		if user_id:
			userData = Users().get_member(user_id)
		else:
			flash(AppMessage.GENERAL_ERROR ,"errorMsg")
			return redirect(url_for('member.getLogin',society_id=society_id,society_key=society_key))       

	user_id  =  userData.user_id;
	if userData.otp: 
		otp_random = userData.otp
	else :  
		otp_random  = Helper.random_otp()
	otp_expire_on   = datetime.now() + timedelta(minutes=30)
	data            = {'otp_expire_on' : otp_expire_on,'otp_sent_at':datetime.now(),'otp' : otp_random,'updated_at'  : datetime.now()}
	Users().update_member(user_id,data)
	if sendOtpMail(email,otp_random,otp_expire_on,society_id,society_key):
		encrypt_user_id  = Cryptography.encrypt(int(user_id))
		return redirect (url_for('member.getOtp',user_id=encrypt_user_id,society_id=society_id,society_key=society_key))
	else:
		flash("Something Wrong, Please Try Again","errorMsg")
		return redirect(url_for('member.getLogin',society_id=society_id,society_key=society_key))   

@app.route('/autologin/<string:user_uuid>/<int:society_id>/<string:society_key>', methods = ["GET","POST"])
@RouteGroup.society_required
def AutoLogin(user_uuid,society_id,society_key):
	userData  = Users().get_autologin_data(user_uuid)
	user_id   = userData['user_id']
	bo_access = Users().check_bo_access(userData['email'],1,society_id,None)
	userData["is_admin"] =  bo_access["is_admin"]
	Auth.login(userData,society_id)
	encrypt_user_id = Cryptography.encrypt(int(user_id))
	return redirect(url_for('member.Dashboard',user_id=encrypt_user_id,society_id=society_id,society_key=society_key))

@app.route('/logout/<int:society_id>/<string:society_key>', methods = ["GET"])
def Logout(society_id,society_key):
	Auth.logout(society_id)
	return redirect (url_for('member.getLogin',society_id=society_id,society_key=society_key))


def sendOtpMail(email,otp_random,otp_expire_on,society_id,society_key):
	try:
		societyData = Auth.checkSocietybyIdKey(society_id,society_key)
		if societyData:
			template_name   = "otp_mail"
			mailData        = MembershipMailTemplates().get_mail_template(society_id,template_name)
			date            = otp_expire_on.strftime("%d %B %Y %H:%M")
			sub_data = {
				'random_otp'    : str(otp_random),
				'society_name'  : societyData['society_intial'],
				'date'          : date,
			}
			subject   = Helper.merge_tags(mailData.subject,sub_data)
			mail_data = {
				'random_otp'    : str(otp_random),
				'society_name'  : societyData['society_intial'],
				'support_mail'  : societyData['e_support_mail'],
				'date'          : date
			}
			mail_content    = Helper.merge_tags(mailData.mail_content,mail_data)
			to              = email
			html            = render_template('memberapp_users/email/mail_template.html',mail_content=mail_content,society_id=society_id,society_key=society_key)
			EMAIL.sendMail(subject,html,to,mailData,societyData)
			flash("An OTP has been sent to your email id "+ to,"successMsg")
			return True
		else:
			return False
	except TypeError as e:
		flash(AppMessage.GENERAL_ERROR ,"errorMsg")
		raise False
		

#randomly generated otp send to email after step 1
#otp random save in db
@app.route('/resend_otp/<user_id>/<int:society_id>/<string:society_key>', methods = ["GET","POST"])
@RouteGroup.society_required
def resendOTP(user_id,society_id,society_key):
	user_id     = unquote(user_id)
	user_id     = int(Cryptography.decrypt(user_id))
	userData    = Users().get_member(user_id)
	if userData.otp: 
		otp_random = userData.otp
	else :  
		otp_random  = Helper.random_otp()
	otp_expire_on   = datetime.now() + timedelta(minutes=30)
	email           = userData.email
	data            = {'otp_expire_on' : otp_expire_on,'otp_sent_at':datetime.now(),'otp' : otp_random,'updated_at'  : datetime.now()}
	Users().update_member(user_id,data)
	if sendOtpMail(email,otp_random,otp_expire_on,society_id,society_key):
		encrypt_user_id  = Cryptography.encrypt(int(user_id))
		return redirect (url_for('member.getOtp',user_id=encrypt_user_id,society_id=society_id,society_key=society_key))
	else:
		flash("Something Wrong, Please Try Again","errorMsg")
		return redirect(url_for('member.getLogin',society_id=society_id,society_key=society_key))   
	
@app.route('/otp/<user_id>/<int:society_id>/<string:society_key>', methods = ["GET"])
@RouteGroup.society_required
def getOtp(user_id,society_id,society_key):
	return render_template('memberapp_users/otp.html',encrypt_user_id=user_id,society_id=society_id,society_key=society_key)

# otp save in db with expiry time
# time validation for otp
# random otp and user enter otp correct or wrong    
@app.route('/otp/<user_id>/<int:society_id>/<string:society_key>', methods = ["POST"])
@RouteGroup.society_required
def postOtp(user_id,society_id,society_key):
	user_id     = unquote(user_id)
	user_id     = int(Cryptography.decrypt(user_id))
	now         = datetime.now()
	pin_1       = request.values.get('input1')
	pin_2       = request.values.get('input2')
	pin_3       = request.values.get('input3')
	pin_4       = request.values.get('input4')
	otp         = pin_1+pin_2+pin_3+pin_4
	userData    = Users().getUserByID(user_id)
	if(int(otp) == userData['otp']) :
		otp_expire_on   = datetime.strptime(str(userData["otp_expire_on"]),'%Y-%m-%d %H:%M:%S')
		if now > otp_expire_on:
			flash("Expired!OTP valid for 30 mintue","errorMsg")
			encrypt_user_id  = Cryptography.encrypt(int(user_id))
			return render_template('memberapp_users/otp.html',encrypt_user_id=encrypt_user_id,user_id=user_id,society_id=society_id,society_key=society_key)
		else:
			data    = {'otp' : None, 'otp_verified_at':datetime.now(),'updated_at'  : datetime.now()}
			output  = Users().update_member(user_id,data)
			if output:
				encrypt_user_id  = Cryptography.encrypt(int(user_id))
				bo_access = Users().check_bo_access(userData['email'],1,society_id,None)
				userData["is_admin"] =  bo_access["is_admin"]
				Auth.login(userData,society_id)
				return redirect(url_for('member.Dashboard',user_id=encrypt_user_id,society_id=society_id,society_key=society_key))
	else:
		flash("Incorrect OTP.  Please provide the correct OTP","errorMsg")
		encrypt_user_id  = Cryptography.encrypt(int(user_id))
		return render_template('memberapp_users/otp.html',encrypt_user_id=encrypt_user_id,user_id=user_id,society_id=society_id,society_key=society_key)

@app.route('/mail_validating/<user_id>/<int:society_id>/<string:society_key>', methods = ["GET","POST"])
@RouteGroup.login_required
@RouteGroup.society_required
def mailValidating(user_id,society_id,society_key):
	user_id        = unquote(user_id)
	user_id        = int(Cryptography.decrypt(user_id))
	userData       = Users().get_member(user_id)
	status         = "step1"
	status_id_1    = MStatus().get_status_id(status,society_id)
	data           = {'status_id' : status_id_1.status_id,'updated_at' : datetime.now()}
	user_logs_data = {'society_id':society_id,'user_id' : user_id,'status_id': status_id_1.status_id,'status':status,'member_type_id':userData.member_type_id,'created_at':datetime.now()}
	UserStatusLogs().insert_status(user_logs_data)
	
	societyData    = Auth.getSociety(society_id)
	if userData.status_id != societyData['ms_rejected_status_id'] :
		Users().update_member(user_id,data)
	step_no = 1
	encrypt_user_id  = Cryptography.encrypt(int(user_id))
	return render_template('memberapp_users/mail_validating_page.html',encrypt_user_id=encrypt_user_id,society_id=society_id,society_key=society_key,status_id=userData.status_id,step_no=step_no,societyData=societyData)

@app.route('/get_step/<user_id>/<step_no>/<int:society_id>/<string:society_key>',methods = ["GET"])
@RouteGroup.login_required
@RouteGroup.society_required
def getStep(user_id,step_no,society_id,society_key):
	current_step,pre_step,nxt_step  = MSteps().usp_get_steps(step_no,society_id)
	if current_step == 0:
		flash("NO STEPS","errorMsg")
		return render_template('memberapp_users/display_msg.html')
	else:
		cur_step = current_step['step_no']
		print(user_id)
		return eval(current_step['get_function_name'] +"(user_id=user_id,cur_step=cur_step,pre_step=pre_step,nxt_step=nxt_step,society_id=society_id,society_key=society_key)")

@app.route('/post_step/<user_id>/<int:society_id>/<string:society_key>',methods = ["GET","POST"])
@RouteGroup.login_required
@RouteGroup.society_required
def postStep(user_id,society_id,society_key):
	step_no     = request.values.get('cur_step')
	# print(step_no)
	# return step_no
	current_step,pre_step,nxt_step      = MSteps().usp_get_steps(step_no,society_id)
	# cur_step = current_step['step_no']
	typ = type(current_step)
# 	return current_step
	if current_step == 0:
# 		return 'testing1'
		flash("Something Wrong, Please Try Again","errorMsg")
		return render_template('memberapp_users/display_msg.html')
	else:
		cur_step = current_step['step_no']
# 		return cur_step
		return eval(current_step['post_function_name'] +"(user_id=user_id,cur_step=cur_step,pre_step=pre_step,nxt_step=nxt_step,society_id=society_id,society_key=society_key)")

@app.route('/member_type/<user_id>/<cur_step>/<pre_step>/<nxt_step>/<int:society_id>/<string:society_key>', methods = ["GET"])
@RouteGroup.login_required
@RouteGroup.society_required
def getMemberType(user_id,cur_step,pre_step,nxt_step,society_id,society_key):
	user_id     = unquote(user_id)
	user_id     = int(Cryptography.decrypt(user_id))
	userData    = Users().get_member(user_id)
	if userData.status_id < 10 :
		if not userData:
			flash("User Not Found","errorMsg")
			return redirect(url_for('member.getLogin',society_id=society_id,society_key=society_key))
		else:
			member_types = MMemberType().count_get_member_registrations(society_id)
			if len(member_types) > 1:
				encrypt_user_id  = Cryptography.encrypt(int(user_id))
				return render_template('memberapp_users/member_type.html',member_types=member_types,user_id=user_id,user=userData,encrypt_user_id=encrypt_user_id,society_id=society_id,society_key=society_key,cur_step=cur_step,pre_step=pre_step,nxt_step=nxt_step)
			else:
				member_type     = member_types[0]
				now             = datetime.now()
				status          = "step2"
				status_id_1     = MStatus().get_status_id(status,society_id)
				# status_id       = status_id_1.status_id
				data_1 = {
				'member_type_id'         : 2,
				'choosed_member_type_id' : member_type['member_type_id'],
				'updated_at'             : datetime.now()
				}
				data_2 = { 'status_id'     : status_id_1.status_id }
				data   = dict(data_1, **data_2)
				if userData.status_id != Auth.getSociety(society_id)['ms_rejected_status_id']:
					output = Users().update_member(user_id,data)
				else:
					output = Users().update_member(user_id,data_1)
				user_logs_data = {'society_id':society_id,'user_id' : user_id,'status_id': status_id_1.status_id,'status':status,'member_type_id':userData.member_type_id,'created_at':datetime.now()}
				UserStatusLogs().insert_status(user_logs_data)
				if output:
					encrypt_user_id  = Cryptography.encrypt(int(user_id))
					step_no          = nxt_step
					return redirect (url_for('member.getStep',user_id=encrypt_user_id,step_no=step_no,society_id=society_id,society_key=society_key))
	else:
		encrypt_user_id  = Cryptography.encrypt(int(user_id))
		if society_id == 18 and userData.status_id == 12:
			member_types = MMemberType().count_get_member_registrations(society_id)
			return render_template('memberapp_users/member_type.html',member_types=member_types,user_id=user_id,user=userData,encrypt_user_id=encrypt_user_id,society_id=society_id,society_key=society_key,cur_step=cur_step,pre_step=pre_step,nxt_step=nxt_step)
		else:
			return redirect (url_for('member.getStep',user_id=encrypt_user_id,step_no=nxt_step,society_id=society_id,society_key=society_key))

@app.route('/member_type/<user_id>/<cur_step>/<pre_step>/<nxt_step>/<int:society_id>/<string:society_key>', methods = ["POST"])
def postMemberType(user_id,cur_step,pre_step,nxt_step,society_id,society_key):
	user_id     = unquote(user_id)
	user_id     = int(Cryptography.decrypt(user_id))
	if request.method == "POST":
		member_type_id  = request.form['member_type']
		status          = "step2"
		
		status_id_1     = MStatus().get_status_id(status,society_id)
#       status_id       = status_id_1.status_id
		userData        = Users().get_member(user_id)
		data_1 = {
			'member_type_id'         : 2,
			'choosed_member_type_id' : member_type_id,
			'updated_at'             : datetime.now()
		}
		data_2 = {'status_id'        : status_id_1.status_id}
		data   = dict(data_1, **data_2)
		if userData.status_id != Auth.getSociety(society_id)['ms_rejected_status_id']:
			output = Users().update_member(user_id,data)
		else:
			output = Users().update_member(user_id,data_1)
			
		
#       member_type_id  = userData.member_type_id
		user_logs_data = {'society_id':society_id,'user_id' : user_id,'status_id': status_id_1.status_id,'status':status,'member_type_id':userData.member_type_id,'created_at':datetime.now()}
		UserStatusLogs().insert_status(user_logs_data)
		if output:
			encrypt_user_id  = Cryptography.encrypt(int(user_id))
			return redirect (url_for('member.getStep',user_id=encrypt_user_id,step_no=nxt_step,society_id=society_id,society_key=society_key))
	else :
		flash("Please, Try again.","errorMsg")
		return redirect(url_for('member.getLogin',society_id=society_id,society_key=society_key))

@app.route('/userprofile/<user_id>/<cur_step>/<pre_step>/<nxt_step>/<int:society_id>/<string:society_key>', methods = ["GET"])
@RouteGroup.login_required
@RouteGroup.society_required
def getUserprofile(user_id,cur_step,pre_step,nxt_step,society_id,society_key,userData = None):
	user_id     = unquote(user_id)
	user_id     = int(Cryptography.decrypt(user_id))
	states      = States().get_states()
	districts   = States().get_districts()
	countries   = Countries().get_countries()
	member_types = MMemberType().count_get_member_registrations(society_id)
	if userData is None:
		userData = Users().get_member(user_id)
		if userData.dob:
			user_dob = userData.dob.day
		else:
			user_dob = None		
		encrypt_user_id  = Cryptography.encrypt(int(user_id))
		return render_template('memberapp_users/user_profile_page.html',user=userData,user_dob= user_dob,states=states,district=districts,countries=countries,user_id=user_id,encrypt_user_id=encrypt_user_id,society_id=society_id,society_key=society_key,cur_step=cur_step,pre_step=pre_step,nxt_step=nxt_step,member_types=member_types)
	else:
		user_dob = userData['dob']
		user_dob = datetime.strptime(str(user_dob), "%Y-%m-%d")
		user_dob = user_dob.day
		encrypt_user_id  = Cryptography.encrypt(int(user_id))
		return render_template('memberapp_users/user_profile_page.html',user=userData,user_dob=user_dob,states=states,district=districts,countries=countries,user_id=user_id,encrypt_user_id=encrypt_user_id,society_id=society_id,society_key=society_key,cur_step=cur_step,pre_step=pre_step,nxt_step=nxt_step,member_types=member_types)
	
@app.route('/userprofile/<user_id>/<cur_step>/<pre_step>/<nxt_step>/<int:society_id>/<string:society_key>', methods = ["POST"])
@RouteGroup.login_required
@RouteGroup.society_required
def postUserprofile(user_id,cur_step,pre_step,nxt_step,society_id,society_key):
	user_id                 = unquote(user_id)
	user_id                 = int(Cryptography.decrypt(user_id))
	userData                = Users().get_member(user_id)
	name                    = request.values.get('name') or None
	prefix                  = request.values.get('prefix') or None
	email                   = request.values.get('email') or None
	mobile                  = request.values.get('mobile') or None
	gender                  = request.values.get('gender') or None
	whatsapp_number         = request.values.get('whatsapp_number') or None
	aadhaar_number          = request.values.get('aadhaar_number',None) or None
	aios_membership_number  = request.values.get('aios_membership_number',None) or None
	address_1               = request.values.get('address_1') or None
	address_2               = request.values.get('address_2') or None
	address_3               = request.values.get('address_3') or None
	district                = request.values.get('district') or None
	other_districts         = request.values.get("other_district") if district == "Others" else None
	city                    = request.values.get('city') or None
	pincode                 = request.values.get('pincode') or None
	country                 = request.values.get('country') or None
	state                   = request.values.get('state') or None
	gov_proof_type          = request.values.get('gov_proof_type') or None
	gov_proof_id            = request.values.get('gov_proof_id') or None
	hos_address1            = request.values.get('hos_address1') or None
	hos_address2            = request.values.get('hos_address2') or None
	hos_address3            = request.values.get('hos_address3') or None
	dob                     = (request.form.get("year",None)+"-"+request.form.get("month",None)+"-"+request.form.get("date",None))
	status                  = "step3"
	is_valid                = True
	status_id_1             = MStatus().get_status_id(status,society_id)
	status_id               = status_id_1.status_id
	data_1 = {
		'user_id'                : user_id,
		'full_name'              : name,
		'prefix'                 : prefix,
		'email'                  : email,
		'mobile'                 : mobile,
		'dob'                    : dob,
		'gender'                 : gender,
		'whatsapp_number'        : whatsapp_number,
		'aadhaar_number'         : aadhaar_number,
		'aios_membership_number' : aios_membership_number,
		'address1'               : address_1,
		'address2'               : address_2,
		'address3'               : address_3,
		'district'               : district,
		'other_districts'        : other_districts,
		'city'                   : city,
		'pincode'                : pincode,
		'country_id'             : int(country) if country else None,
		'state_id'               : int(state) if state else None,
		'gov_proof_type'         : gov_proof_type,
		'gov_proof_id'           : gov_proof_id,
		'hos_address1'           : hos_address1,
		'hos_address2'           : hos_address2,
		'hos_address3'           : hos_address3,
		'updated_at'             : datetime.now()
	}
	data_2 = { 'status_id'       : status_id }
	data = dict(data_1, **data_2)
	count_mobile        = Users().count_mobile_num(user_id,mobile,society_id)
	name            	= count_mobile[0]
	email          		= count_mobile[1]
	mobile_count        = count_mobile[2]
	member_type_id      = userData.member_type_id

	if whatsapp_number is not None:
		count_whatsapp  = Users().count_whatsapp_num(user_id,whatsapp_number,society_id)
		wname            = count_whatsapp[0]
		wemail           = count_whatsapp[1]
		whatsapp_count  = count_whatsapp[2]
		if int(whatsapp_count) > 0 :
			flash('This Whatsapp number is already associated with an existing record -  <b>'+ (wname if wname else wemail) +'</b> <br> Please provide an alternate number',"errorMsg")
			is_valid = False

	if int(mobile_count) > 0 :
		flash('This mobile number is already associated with an existing record -  <b>'+ (name if name else email) +'</b> <br> Please provide an alternate number',"errorMsg")
		is_valid = False

	if is_valid:
		if userData.status_id != Auth.getSociety(society_id)['ms_rejected_status_id']:  
			output = Users().update_member(user_id,data)
		else:
			output = Users().update_member(user_id,data_1)
		user_logs_data = {'society_id':society_id,'user_id' : user_id,'status_id': status_id,'status':status,'member_type_id':member_type_id,'created_at':datetime.now()}
		UserStatusLogs().insert_status(user_logs_data)
		if output:
			encrypt_user_id  = Cryptography.encrypt(int(user_id))
			return redirect (url_for('member.getStep',user_id=encrypt_user_id,step_no=nxt_step,society_id=society_id,society_key=society_key))
	else: 
		encrypt_user_id  = Cryptography.encrypt(int(user_id))
		return getUserprofile(encrypt_user_id,cur_step,pre_step,nxt_step,society_id,society_key,data)

# For selecting country, state will shown in dropdown using ajaax
@app.route('/state/<int:society_id>/<string:society_key>', methods = ["GET","POST"])
def State(society_id,society_key):
	country_id = request.values['country_id']
	data       = States().get_states_of_india(country_id)
	return json.dumps(data)

@app.route('/qualificaton/<user_id>/<cur_step>/<pre_step>/<nxt_step>/<int:society_id>/<string:society_key>', methods = ["GET"])
@RouteGroup.login_required
@RouteGroup.society_required
def getQualification(user_id,cur_step,pre_step,nxt_step,society_id,society_key,data=None):
	user_id         = unquote(user_id)
	user_id         = int(Cryptography.decrypt(user_id))
	country_id      = Auth.getSociety(society_id)['default_country_id']
	states_of_india = States().get_states_of_india(country_id)
	if data is None:
		userData        = Users().get_member(user_id)
		encrypt_user_id = Cryptography.encrypt(int(user_id))
		return render_template('memberapp_users/qualification.html',user_id=user_id,user=userData,states_of_india=states_of_india,encrypt_user_id=encrypt_user_id,society_id=society_id,society_key=society_key,cur_step=cur_step,pre_step=pre_step,nxt_step=nxt_step)
	else:
		encrypt_user_id = Cryptography.encrypt(int(user_id))
		return render_template('memberapp_users/qualification.html',user_id=user_id,user=data,states_of_india=states_of_india,encrypt_user_id=encrypt_user_id,society_id=society_id,society_key=society_key,cur_step=cur_step,pre_step=pre_step,nxt_step=nxt_step)

@app.route('/qualification/<user_id>/<cur_step>/<pre_step>/<nxt_step>/<int:society_id>/<string:society_key>', methods = ["POST"])
@RouteGroup.society_required
def postQualification(user_id,cur_step,pre_step,nxt_step,society_id,society_key):
	user_id      = unquote(user_id)
	mc_number    = request.values.get('mc_number') or None
	mc_state     = request.values.get('mc_state') or None
	is_pg        = request.values.get('is_pg') or None
	status       = "step4"
	status_id_1  =  MStatus().get_status_id(status,society_id)
#   status_id    = status_id_1.status_id
	data_1={
		'mc_number'     : mc_number,
		'mc_state_id'   : mc_state,
		'is_pg'         : is_pg,
		'updated_at'    : datetime.now(),
	}
	data_2 = {'status_id': status_id_1.status_id}
	data   = dict(data_1, **data_2)
	# get qualification count by user_id 
	user_id         = int(Cryptography.decrypt(user_id))
	count_user_id   = UserQualification().count_qul_user_id(user_id)
	count           = count_user_id.count if count_user_id else 0
	# if count == 0 or none reirect this step and show message
	if count == 0:
		flash('Please add atleast one qualification',"errorMsg")
		encrypt_user_id  = Cryptography.encrypt(int(user_id))
		return getQualification(encrypt_user_id,cur_step,pre_step,nxt_step,society_id,society_key,data_1)

	# if qualification count > 0 and output success redirect to next step
	else:
		userData = Users().get_member(user_id)
#       member_type_id = userData.member_type_id
		if userData.status_id != Auth.getSociety(society_id)['ms_rejected_status_id']: 
			output = Users().update_member(user_id,data)
		else:
			output = Users().update_member(user_id,data_1)
		user_logs_data = {'society_id':society_id,'user_id' : user_id,'status_id': status_id_1.status_id,'status':status,'member_type_id':userData.member_type_id,'created_at':datetime.now()}
		UserStatusLogs().insert_status(user_logs_data)
		encrypt_user_id  = Cryptography.encrypt(int(user_id))
		return redirect (url_for('member.getStep',user_id=encrypt_user_id,step_no=nxt_step,society_id=society_id,society_key=society_key))

@app.route('/insert_qualification/<int:society_id>/<string:society_key>', methods = ["GET", "POST"])
def InsertQualification(society_id,society_key):
	if request.method == "POST":
		user_id       = request.form['user_id']
		uq_id         = request.form['uq_id']
		qualification = request.form['qualification']
		year_from     = request.form['year_from']
		year_passing  = request.form['year_passing']
		institution   = request.form['institution']
		data = {
			'user_id'           : user_id,
			'uq_id'             : uq_id,
			'qualification'     : qualification,
			'year_from'         : year_from,
			'year_passing'      : year_passing,
			'institution'       : institution,
			'created_at'        : datetime.now(),
			'updated_at'        : datetime.now(),
			}
		update_or_insert = UserQualification().update_or_insert(user_id,uq_id,data) 
		return render_template('memberapp_users/qualification_table.html',data = update_or_insert,society_id=society_id,society_key=society_key)
			
#Get Qualification data 
@app.route('/get_qualifications_by_user/<int:society_id>/<string:society_key>', methods = ["GET","POST"])
def get_qualifications_by_user(society_id,society_key):
	user_id = request.values['user_id']
	data    = UserQualification().get_qulification_by_user(user_id)
	return render_template('memberapp_users/qualification_table.html',data = data,society_id=society_id,society_key=society_key)

@app.route('/get_qualification/<int:society_id>/<string:society_key>',methods = ["GET","POST"])
def get_qualification(society_id,society_key):
	uq_id   = request.form['uq_id']
	data    = UserQualification().get_qualification(uq_id) 
	return json.dumps(data)

@app.route('/delete_qualification/<int:society_id>/<string:society_key>',methods = ["GET","POST"])
def delete_qualification(society_id,society_key):
	uq_id   = request.form['uq_id']
	user_id = request.form['user_id']
	UserQualification().delete_qualification(uq_id)
	data    = UserQualification().get_qulification_by_user(user_id)
	return render_template('memberapp_users/qualification_table.html',data = data,society_id=society_id,society_key=society_key)


############### Training and endoscopic for IAGES ############
@app.route('/training/<user_id>/<cur_step>/<pre_step>/<nxt_step>/<int:society_id>/<string:society_key>', methods = ["GET"])
@RouteGroup.login_required
@RouteGroup.society_required
def getTraining(user_id,cur_step,pre_step,nxt_step,society_id,society_key):
	user_id         = unquote(user_id)
	user_id         = int(Cryptography.decrypt(user_id))
	userData        = Users().get_member(user_id)
	if not userData:
		flash("User Not Found","errorMsg")
		return redirect(url_for('member.getLogin',society_id=society_id,society_key=society_key))
	else:
		encrypt_user_id  = Cryptography.encrypt(int(user_id))
		return render_template('memberapp_users/user_training.html',user_id=user_id,encrypt_user_id=encrypt_user_id,society_id=society_id,society_key=society_key,cur_step=cur_step,pre_step=pre_step,nxt_step=nxt_step)

@app.route('/training/<user_id>/<cur_step>/<pre_step>/<nxt_step>/<int:society_id>/<string:society_key>', methods = ["POST"])
@RouteGroup.society_required
def postTraining(user_id,cur_step,pre_step,nxt_step,society_id,society_key):
	user_id      = unquote(user_id)
	status       = "step4"
	status_id_1  =  MStatus().get_status_id(status,society_id)
#   status_id    = status_id_1.status_id
	data={
		'status_id'   : status_id_1.status_id,
		'updated_at'  : datetime.now()
	}
	user_id         = int(Cryptography.decrypt(user_id))
	count_user_id   = UserTraining().count_training_user_id(user_id)
	count           = count_user_id['user_id']
	if count == 0:
		flash('Please add your Training in endoscopic surgery/procedures',"errorMsg")
		encrypt_user_id  = Cryptography.encrypt(int(user_id))
		return redirect (url_for('member.getStep',user_id=encrypt_user_id,step_no=cur_step,society_id=society_id,society_key=society_key))
	else:
		userData = Users().get_member(user_id)
#       member_type_id = userData.member_type_id
		if userData.status_id != Auth.getSociety(society_id)['ms_rejected_status_id']: 
			output = Users().update_member(user_id,data)
		user_logs_data = {'society_id':society_id,'user_id' : user_id,'status_id': status_id_1.status_id,'status':status,'member_type_id':userData.member_type_id,'created_at':datetime.now()}
		UserStatusLogs().insert_status(user_logs_data)
		encrypt_user_id  = Cryptography.encrypt(int(user_id))
		return redirect (url_for('member.getStep',user_id=encrypt_user_id,step_no=nxt_step,society_id=society_id,society_key=society_key))

@app.route('/insert_training/<int:society_id>/<string:society_key>', methods = ["GET", "POST"])
def insertTraining(society_id,society_key):
	if request.method == "POST":
		user_id       = request.form['user_id']
		ut_id         = request.form['ut_id']
		institution   = request.form['institution']
		from_date     = datetime.strptime(request.form['from_date'], "%d-%m-%Y")
		duration      = request.form['duration']
		teacher       = request.form['teacher']
		data = {
			'user_id'       : user_id,
			'ut_id'         : ut_id,
			'institution'   : institution,
			'from_date'     : from_date,
			'duration'      : duration,
			'teacher'       : teacher,
			'created_at'    : datetime.now(),
			'updated_at'    : datetime.now()
			}
		update_or_insert = UserTraining().update_or_insert(user_id,ut_id,data) 
		return render_template('memberapp_users/user_training_table.html',data = update_or_insert,society_id=society_id,society_key=society_key)
			
#Get Qualification data 
@app.route('/get_training_by_user/<int:society_id>/<string:society_key>', methods = ["GET","POST"])
def getTrainingByUser(society_id,society_key):
	user_id = request.values['user_id']
	data    = UserTraining().get_training_by_user(user_id)
	return render_template('memberapp_users/user_training_table.html',data = data,society_id=society_id,society_key=society_key)

@app.route('/get_training/<int:society_id>/<string:society_key>',methods = ["GET","POST"])
def get_training(society_id,society_key):
	ut_id   = request.form['ut_id']
	data    = UserTraining().get_training(ut_id) 
	return json.dumps(data)

@app.route('/delete_training/<int:society_id>/<string:society_key>',methods = ["GET","POST"])
def deleteTraining(society_id,society_key):
	ut_id   = request.form['ut_id']
	user_id = request.form['user_id']
	UserTraining().delete_training(ut_id)
	data    = UserTraining().get_training_by_user(user_id)
	return render_template('memberapp_users/user_training_table.html',data = data,society_id=society_id,society_key=society_key)


@app.route('/work/<user_id>/<cur_step>/<pre_step>/<nxt_step>/<int:society_id>/<string:society_key>', methods = ["GET"])
@RouteGroup.login_required
@RouteGroup.society_required
def getWork(user_id,cur_step,pre_step,nxt_step,society_id,society_key):
	user_id     = unquote(user_id)
	user_id     = int(Cryptography.decrypt(user_id))
	userData    = Users().get_member(user_id)
	if not userData:
		flash("User Not Found","errorMsg")
		return redirect(url_for('member.getLogin',society_id=society_id,society_key=society_key))
	else:
		work_types       = MWorkType().get_work_type(society_id)
		position_types   = MWorkType().get_position_type(society_id)
		encrypt_user_id  = Cryptography.encrypt(int(user_id))
		return render_template('memberapp_users/userworks.html',user_id=user_id,work_types=work_types,position_types=position_types,encrypt_user_id=encrypt_user_id,society_id=society_id,society_key=society_key,cur_step=cur_step,pre_step=pre_step,nxt_step=nxt_step)

@app.route('/work/<user_id>/<cur_step>/<pre_step>/<nxt_step>/<int:society_id>/<string:society_key>', methods = ["POST"])
@RouteGroup.society_required
def postWork(user_id,cur_step,pre_step,nxt_step,society_id,society_key):
	user_id         = unquote(user_id)
	user_id         = int(Cryptography.decrypt(user_id))
	status          = "step5"
	status_id_1     = MStatus().get_status_id(status,society_id)
#   status_id       = status_id_1.status_id
	data            = {'status_id':status_id_1.status_id,'updated_at'  : datetime.now()}
	count_user_id   = UserWork().count_work_user_id(user_id)
	count           = count_user_id.count if count_user_id else 0
	if count == 0 and int(society_id) != 2:
		flash('Please add your Experience',"errorMsg")
		encrypt_user_id  = Cryptography.encrypt(int(user_id))
		return redirect (url_for('member.getStep',user_id=encrypt_user_id,step_no=cur_step,society_id=society_id,society_key=society_key))
	else:
		userData = Users().get_member(user_id)
#       member_type_id=userData.member_type_id
		if userData.status_id != Auth.getSociety(society_id)['ms_rejected_status_id'] :
			Users().update_member(user_id,data)
		user_logs_data = {'society_id':society_id,'user_id' : user_id,'status_id': status_id_1.status_id,'status':status,'member_type_id':userData.member_type_id,'created_at':datetime.now()}
		UserStatusLogs().insert_status(user_logs_data)
		encrypt_user_id  = Cryptography.encrypt(int(user_id))
		return redirect (url_for('member.getStep',user_id=encrypt_user_id,step_no=nxt_step,society_id=society_id,society_key=society_key))

@app.route('/insert_work/<int:society_id>/<string:society_key>', methods = ["GET", "POST"])
def InsertWork(society_id,society_key):
	if request.method == "POST":
		work_id          = request.form['work_id']
		user_id          = request.form['user_id']
		work_type_id     = request.form['work_type_id']
		position_type_id = request.values.get('position_type_id',None)
		work_status      = request.form['work_status']
		work_since       = request.values.get('work_since',None)
		work_until       = request.values.get('work_until',None)
		work_place       = request.form['work_place']
		data = {
			'work_id'       : work_id,
			'user_id'       : user_id,
			'work_type_id'  : work_type_id,
			'position_type_id':position_type_id,
			'work_status'   : work_status,
			'work_since'    : work_since,
			'work_until'    : work_until,
			'work_place'    : work_place,
			'created_at'    : datetime.now(),
			'updated_at'    : datetime.now(),
		}
		work_data = UserWork().update_or_insert_work(user_id,work_id,data)
		return render_template('memberapp_users/userworks_table.html',data = work_data,society_id=society_id,society_key=society_key)
		
@app.route('/get_work_by_user/<int:society_id>/<string:society_key>',methods = ["GET","POST"])
def get_work_by_user(society_id,society_key):
	user_id = request.values["user_id"]
	data    = MWorkType().get_work_type_by_user(user_id)
	return render_template('memberapp_users/userworks_table.html',data = data,society_id=society_id,society_key=society_key)

#edit work
@app.route('/get_work/<int:society_id>/<string:society_key>',methods = ["GET","POST"])
def get_work(society_id,society_key):
	work_id = request.values['work_id']
	data    = UserWork().get_work(work_id)
	return json.dumps(data)

@app.route('/delete_work/<int:society_id>/<string:society_key>',methods = ["GET","POST"])
def delete_work(society_id,society_key):
	work_id = request.form['work_id']
	user_id = request.form['user_id']
	UserWork().delete_work(work_id)
	data    = MWorkType().get_work_type_by_user(user_id)
	return render_template('memberapp_users/userworks_table.html',data = data,society_id=society_id,society_key=society_key)

@app.route('/publication/<user_id>/<cur_step>/<pre_step>/<nxt_step>/<int:society_id>/<string:society_key>', methods = ["GET"])
@RouteGroup.login_required
@RouteGroup.society_required
def getPublication(user_id,cur_step,pre_step,nxt_step,society_id,society_key):
	user_id     = unquote(user_id)
	user_id     = int(Cryptography.decrypt(user_id))
	userData    = Users().get_member(user_id)
	if not userData:
		flash("User Not Found","errorMsg")
		return redirect(url_for('member.getLogin',society_id=society_id,society_key=society_key))
	else:
		encrypt_user_id  = Cryptography.encrypt(int(user_id))
		return render_template('memberapp_users/publication.html',user_id=user_id,encrypt_user_id=encrypt_user_id,society_id=society_id,society_key=society_key,cur_step=cur_step,pre_step=pre_step,nxt_step=nxt_step)

@app.route('/publication/<user_id>/<cur_step>/<pre_step>/<nxt_step>/<int:society_id>/<string:society_key>', methods = ["POST"])
@RouteGroup.society_required
def postPublication(user_id,cur_step,pre_step,nxt_step,society_id,society_key):
	user_id         = unquote(user_id)
	user_id         = int(Cryptography.decrypt(user_id))
	status          = "step6"
	status_id_1     = MStatus().get_status_id(status,society_id)
#   status_id       = status_id_1.status_id
	data            = {'status_id':status_id_1.status_id,'updated_at': datetime.now()}
	userData        = Users().get_member(user_id)
#   member_type_id  = userData.member_type_id
	if userData.status_id != Auth.getSociety(society_id)['ms_rejected_status_id'] :
		Users().update_member(user_id,data)
	user_logs_data = {'society_id':society_id,'user_id' : user_id,'status_id': status_id_1.status_id,'status':status,'member_type_id':userData.member_type_id,'created_at':datetime.now()}
	UserStatusLogs().insert_status(user_logs_data)
	encrypt_user_id  = Cryptography.encrypt(int(user_id))
	return redirect (url_for('member.getStep',user_id=encrypt_user_id,step_no=nxt_step,society_id=society_id,society_key=society_key))
	
@app.route('/insert_publication/<int:society_id>/<string:society_key>', methods = ["GET", "POST"])
def InsertPublication(society_id,society_key):
	if request.method == "POST":
		publication_id      = request.form['publication_id']
		user_id             = request.form['user_id']
		author_type         = request.form['author_type']
		author_description  = request.form['author_description']
		data = {
			'publication_id'        : publication_id,
			'user_id'               : user_id,
			'author_type'           : author_type,
			'author_description'    : author_description,
			'created_at'            : datetime.now(),
			'updated_at'            : datetime.now(),
		}
		publication_data = Userpublication().update_or_insert_publication(user_id,publication_id,data)  
		return render_template('memberapp_users/publication_table.html',data = publication_data,society_id=society_id,society_key=society_key)
		
@app.route('/get_publication_by_user/<int:society_id>/<string:society_key>',methods = ["GET","POST"])
def get_publication_by_user(society_id,society_key):
	user_id = request.values["user_id"]
	data    = Userpublication().get_publication_by_user(user_id)
	return render_template('memberapp_users/publication_table.html',data = data,society_id=society_id,society_key=society_key)

#edit work
@app.route('/get_publication/<int:society_id>/<string:society_key>',methods = ["GET","POST"])
def get_publication(society_id,society_key):
	publication_id  = request.values['publication_id']
	data            = Userpublication().get_publication(publication_id)
	return json.dumps(data)

@app.route('/delete_publication/<int:society_id>/<string:society_key>',methods = ["GET","POST"])
def delete_publication(society_id,society_key):
	publication_id  = request.form['publication_id']
	user_id         = request.form['user_id']
	Userpublication().delete_publication(publication_id)
	data            = Userpublication().get_publication_by_user(user_id)
	return render_template('memberapp_users/publication_table.html',data = data,society_id=society_id,society_key=society_key)

@app.route('/attachment/<user_id>/<cur_step>/<pre_step>/<nxt_step>/<int:society_id>/<string:society_key>', methods = ["GET"])
@RouteGroup.login_required
@RouteGroup.society_required
def getAttachment(user_id,cur_step,pre_step,nxt_step,society_id,society_key):
	societyData     = Auth.getSociety(society_id)
	user_id     = unquote(user_id)
	user_id     = int(Cryptography.decrypt(user_id))
	userData    = Users().get_member(user_id)
	if not userData:
		flash("User Not Found","errorMsg")
		return redirect(url_for('member.getLogin',society_id=society_id,society_key=society_key))
	else:
		is_pg      = userData.is_pg
		is_payment = 0  # 1 is with payment screen and 0 is without payment screen and none is both 
		if is_pg is not None :
			datas   = MAttachmentType().get_image_pg(user_id,is_payment,is_pg,society_id)
		else:
			datas   = MAttachmentType().get_image(user_id,is_payment,society_id)
		encrypt_user_id     = Cryptography.encrypt(int(user_id))
		return render_template('memberapp_users/userattach_new.html',user_id=user_id,datas=datas,encrypt_user_id=encrypt_user_id,society_id=society_id,society_key=society_key,cur_step=cur_step,pre_step=pre_step,nxt_step=nxt_step,societyData=societyData)
		
@app.route('/attachment/<user_id>/<cur_step>/<pre_step>/<nxt_step>/<int:society_id>/<string:society_key>', methods = ["POST"])
@RouteGroup.login_required
@RouteGroup.society_required
def postAttachment(user_id,cur_step,pre_step,nxt_step,society_id,society_key):
	user_id             = unquote(user_id)
	user_id             = int(Cryptography.decrypt(user_id))
	userData            = Users().get_member(user_id)
	is_pg               = userData.is_pg
	is_payment          = 0  # 1 is with payment screen and 0 is without payment screen and none is both 
	if is_pg is not None :
		image   = MAttachmentType().get_image_pg(user_id,is_payment,is_pg,society_id)
	else:
		image   = MAttachmentType().get_image(user_id,is_payment,society_id)
	required_at         = []
	for d in image :
		if d['attach_file_name'] == None  and d['is_mandatory'] == 1:
			required_at.append(d['attach_type'])
	if len(required_at) > 0:    
		msg = "Mandatory files to be uploaded before proceeding further..<br><ul>"+''.join(['<li>' + str(s) + '</li>' for s in required_at])+"</ul>"
		flash(msg,"errorMsg")
		encrypt_user_id  = Cryptography.encrypt(int(user_id))
		return redirect (url_for('member.getStep',user_id=encrypt_user_id,step_no=cur_step,society_id=society_id,society_key=society_key))
	else:
		now         = datetime.now()
		status      = "step6"
		status_id_1 = MStatus().get_status_id(status,society_id)
#       status_id   = status_id_1.status_id
		data        = {'updated_at'  : datetime.now(),'status_id':status_id_1.status_id}
		userData    = Users().get_member(user_id)
#       member_type_id = userData.member_type_id
		if userData.status_id != Auth.getSociety(society_id)['ms_rejected_status_id'] :
			Users().update_member(user_id,data)
		user_logs_data = {'society_id':society_id,'user_id' : user_id,'status_id': status_id_1.status_id,'status':status,'member_type_id':userData.member_type_id,'created_at':datetime.now()}
		UserStatusLogs().insert_status(user_logs_data)
		encrypt_user_id  = Cryptography.encrypt(int(user_id))
		return redirect (url_for('member.getStep',user_id=encrypt_user_id,step_no=nxt_step,society_id=society_id,society_key=society_key))

########################## IMAGE UPLOAD ###################################
@app.route('/post_amzon_upload/<int:society_id>/<string:society_key>', methods = ["GET","POST"])
@RouteGroup.login_required
@RouteGroup.society_required
def PostAmazonUpload(society_id,society_key,acl="public-read"):
	if request.method == 'POST':
		user_id         = request.values.get('user_id')
		attach_id       = request.values['attach_id'] 
		attach_type_id  = request.form['attach_type_id']
		societyData     = Auth.getSociety(society_id)
		s3              = boto3.client("s3",aws_access_key_id='AKIAILLDAQ7NFUMVOYLQ',aws_secret_access_key='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')
		files           = request.files.getlist("file")
		for file in files:
			if file.filename:
				filename        = secure_filename(file.filename)
				split_tup       = os.path.splitext(filename)
				file_name       = split_tup[0]
				file_extension  = split_tup[1]
				datas           = MAttachmentType().get_attach_type(attach_type_id)
				attach_type     = datas['attach_type']
				file_str        = attach_type+file_extension
				if " " in file_str :
					file_str = file_str.replace(" ","")
				try:
					bucket     = societyData['aws_bucket']
					user_id    = str(user_id)
					if bucket == 'common-application':
						foldername = str(society_key)+"/user_attachment"
					else:
						foldername = "user_attachment"
					response   = s3.upload_fileobj(file, bucket,foldername+'/'+user_id+'/'+ file_str, ExtraArgs={"ACL": acl,"ContentType": file.content_type})
					data_1     = {'bucketname' : societyData['aws_bucket'],'foldername':foldername,'file_name':file_str+"?"+str(Helper.getcurrenttimestamp()),'msg':'Image successfully uploded','file_extension':file_extension,'status':1} 
					file_path  = societyData['aws_url']+foldername+"/"+user_id

					data = {
						'user_id'           : user_id,
						'attach_type_id'    : attach_type_id,
						'attach_file_name'  : file_str,
						'attach_path'       : file_path,
						'created_at'        : datetime.now(),
						'updated_at'        : datetime.now()  
					}
					if (int(attach_id) > 0):
						ua  = UserAttachments().get_user_attach(attach_id,attach_type_id)
						if ua:
							data.pop("created_at") 
							data           = UserAttachments().update_image(attach_id,data)
							d              = {}
							d['attach_id'] = attach_id
							data_1.update(d)
					else :
						attach_id_pk    = UserAttachments().insert_image(data)
						d               = {}
						d['attach_id']  = attach_id_pk
						data_1.update(d)
					return json.dumps(data_1)
				except ClientError as e:
					logging.error(e)
					data_1      = {'msg':'Image upload failed .Please try again.','status':0}        
					json_data   = json.dumps(data_1)
					return json_data
					# flash('Something Error .Please Try Again')
	else :
		flash("Please, Try again.","errorMsg")
		return redirect(url_for('member.getLogin',society_id=society_id,society_key=society_key))

@app.route('/amazon_upload_photograph/<int:society_id>/<string:society_key>', methods = ["GET","POST"])       
@RouteGroup.society_required
def AmazonUploadPhotograph(society_id,society_key):
	if request.method == 'POST':
		user_id         = request.values.get('user_id')
		attach_id       = request.values['attach_id'] 
		attach_type_id  = request.form['attach_type_id']
		image_data      = request.form['image_data']
		file_name       = request.form['file_name']
		societyData     = Auth.getSociety(society_id)
		acl="public-read"
		s3 = boto3.client("s3",aws_access_key_id='AKIAILLDAQ7NFUMVOYLQ',aws_secret_access_key='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')
		if file_name:
			split_tup       = os.path.splitext(file_name)
			file_name       = split_tup[0]
			file_extension  = split_tup[1]
			datas           = MAttachmentType().get_attach_type(attach_type_id)
			attach_type     = datas['attach_type']
			file_str        = attach_type+file_extension
			if " " in file_str :
				file_str = file_str.replace(" ","")
		try:
			bucket     = societyData['aws_bucket']
			user_id    = str(user_id)
			if bucket == 'common-application':
				foldername = str(society_key)+"/user_attachment"
			else:
				foldername = "user_attachment"
			if image_data:      
				image_data = base64.b64decode(image_data.split(',')[1])
				image = Image.open(io.BytesIO(image_data))
				if image.mode == 'RGBA':
					image = image.convert('RGB')
				image.save(os.path.join('core/static/temp_images', file_str))
				img_path = os.path.join('core/static/temp_images/'+ file_str)
				with open(img_path, 'rb') as f:
					response = s3.upload_fileobj(f,bucket,foldername+'/'+user_id+'/'+ file_str, ExtraArgs={"ACL": acl, "ContentType": "image/jpeg"})        
				os.remove('core/static/temp_images/'+ file_str)
				data_1     = {'bucketname' : societyData['aws_bucket'],'foldername':foldername,'file_name':file_str+"?"+str(Helper.getcurrenttimestamp()),'msg':'Image successfully uploded','file_extension':file_extension,'status':1} 
				file_path  = societyData['aws_url']+foldername+"/"+user_id

				data = {
							'user_id'           : user_id,
							'attach_type_id'    : attach_type_id,
							'attach_file_name'  : file_str,
							'attach_path'       : file_path,
							'created_at'        : datetime.now(),
							'updated_at'        : datetime.now()  
						}
				if (int(attach_id) > 0):
					ua  = UserAttachments().get_user_attach(attach_id,attach_type_id)
					if ua:
						data.pop("created_at") 
						data           = UserAttachments().update_image(attach_id,data)
						d              = {}
						d['attach_id'] = attach_id
						data_1.update(d)
				else :
					attach_id_pk    = UserAttachments().insert_image(data)
					d               = {}
					d['attach_id']  = attach_id_pk
					data_1.update(d)
			return json.dumps(data_1)
		except ClientError as e:
			logging.error(e)
			data_1      = {'msg':'Image upload failed .Please try again.','status':0}        
			json_data   = json.dumps(data_1)
			return json_data
	else :
		flash("Please, Try again.","errorMsg")
		return redirect(url_for('member.getLogin',society_id=society_id,society_key=society_key))
		
	 

@app.route('/delete_amazon_image/<int:society_id>/<string:society_key>', methods = ["GET","POST"])
@RouteGroup.society_required
def DeleteAmazonImage(society_id,society_key):
	attach_id       = request.form['attach_id']
	attach_type_id  = request.form['attach_type_id']
	societyData     = Auth.getSociety(society_id)
	ua              = UserAttachments().get_user_attach(attach_id,attach_type_id)
	if ua is None:
		data = {'msg':'Deleted','status' : 1}
	else:
		filepath        = ua['attach_path']
		filename        = ua['attach_file_name']
		foldername      = filepath+ "/"+filename
		foldername      = foldername.replace(societyData['aws_url'], "")
		s3              = boto3.resource("s3",aws_access_key_id='AKIAILLDAQ7NFUMVOYLQ',aws_secret_access_key='EEudWCsWeCIt/J9/z5m5htmUdGFJNzWFPvNQBIp/')
		response        = s3.Object(societyData['aws_bucket'], foldername).delete()
		UserAttachments().delete_image(attach_id,attach_type_id)
		data            = {'msg':'Deleted','status' : 1}
	json_data   = json.dumps(data)
	return json_data

# step 7 for selecting proposer and seconder
@app.route('/prosec/<user_id>/<cur_step>/<pre_step>/<nxt_step>/<int:society_id>/<string:society_key>', methods = ["GET"])
@RouteGroup.login_required
@RouteGroup.society_required
def getProSec(user_id,cur_step,pre_step,nxt_step,society_id,society_key):
	user_id         = unquote(user_id)
	user_id         = int(Cryptography.decrypt(user_id))
	status          = "step7"
	status_id_1     = MStatus().get_status_id(status,society_id)
#   status_id       = status_id_1.status_id
	data            = {'status_id':status_id_1.status_id,'updated_at'  : datetime.now()}
	userData        = Users().get_member(user_id)
#   member_type_id  = userData.member_type_id
	user_logs_data  = {'society_id':society_id,'user_id' : user_id,'status_id': status_id_1.status_id,'status':status,'member_type_id':userData.member_type_id,'created_at':datetime.now()}
	UserStatusLogs().insert_status(user_logs_data)
	if userData.status_id != Auth.getSociety(society_id)['ms_rejected_status_id'] :
		Users().update_member(user_id,data)
	if not userData:
		flash("User Not Found","errorMsg")
		return redirect(url_for('member.getLogin',society_id=society_id,society_key=society_key))
	else:
		encrypt_user_id  = Cryptography.encrypt(int(user_id))
		return render_template('memberapp_users/proposer_seconder.html',user_id=user_id,encrypt_user_id=encrypt_user_id,society_id=society_id,society_key=society_key,cur_step=cur_step,pre_step=pre_step,nxt_step=nxt_step)

@app.route('/prosec/<user_id>/<cur_step>/<pre_step>/<nxt_step>/<int:society_id>/<string:society_key>', methods = ["POST"])
def postProSec(user_id,cur_step,pre_step,nxt_step,society_id,society_key):
	user_id         = unquote(user_id)
	user_id         = int(Cryptography.decrypt(user_id))
	count_pro_sec   = Reference().count_pro_sec(user_id)
	if count_pro_sec['user_id'] <= 1:
		flash("Please select both Proposer and Seconder","errorMsg")
		encrypt_user_id  = Cryptography.encrypt(int(user_id))
		return redirect (url_for('member.getStep',user_id=encrypt_user_id,step_no=cur_step,society_id=society_id,society_key=society_key))
	else:
		user_id  = Cryptography.encrypt(int(user_id))
		return redirect (url_for('member.Confirmation',user_id=user_id,society_id=society_id,society_key=society_key,step_no=cur_step))

# search the member data for selecting proposer and seconder
@app.route('/search_member/<int:society_id>/<string:society_key>', methods = ["GET", "POST"])
def search_member(society_id,society_key):
	if request.method == 'POST':
		search_data = request.form['search_value']
		search_data = search_data.strip()
		if "-" in search_data:
			searchData = search_data.split("-")
			searchUser = searchData[0]+"|"+searchData[1]
		elif " " in search_data:    
			searchData = search_data.split(" ")
			searchUser = searchData[0]+"|"+searchData[1]
		else:
			searchUser = search_data
		if int(society_id) == 1:
			is_prosec = None
		else:
			is_prosec = 1
		type        = request.form['type']
		members     = Users().usp_search_prosec(searchUser,is_prosec,society_id)
		if members is None:
			msg = "User Not Found"
			return render_template('memberapp_users/prosec_table.html',members = members,type=type,msg=msg,society_id=society_id,society_key=society_key)
		else:
			return render_template('memberapp_users/prosec_table.html',members = members,type=type,society_id=society_id,society_key=society_key)
	else:
		return "Please Try again"

# after select proposer and seconder-insert and update in db
# proposer and seconder must not be same 
@app.route('/insert_prosec/<int:society_id>/<string:society_key>', methods = ["GET", "POST"])
def insert_prosec(society_id,society_key):
	if request.method == "POST":
		isvalid         = True
		msg             = ""
		status          = 0
		reference_id    = request.values['reference_id']
		user_id         = request.form['user_id']
		ps_type         = request.form['type']
		reference_by    = request.form['user_id_refer']
		next_reminder_date = datetime.now() + timedelta(days=3)
		data    = {
					'user_id'           : user_id,
					'type'              : ps_type,
					'reference_by'      : reference_by,
					'next_reminder_date': next_reminder_date,
					'created_at'        : datetime.now(),
					'updated_at'        : datetime.now(),
			}
		datas    = Users().get_member(user_id=reference_by)
		ps_email = datas.email
		if ps_email is None:
			msg    = "It is mandatory that valid email ids are required for the "+ps_type+" .  Please choose an alternative "+ps_type+" or contact your  "+ps_type+"  and request to update their email id"
			status = 0
		else:
			if int(reference_by) > 0:
				d = Reference().get_reference(user_id,reference_by)
				if d:
					if (d["type"] != ps_type):
						msg     = "The proposer and seconder cannot be the same."
						status  = 0
						isvalid = False
			if isvalid == True:
				if (int(reference_id) > 0):
					data.pop("created_at")
					data    = Reference().update_prosec(user_id,ps_type,data)
					status  = 1
				else:
					Reference().insert_prosec(data)
					status = 1
		return jsonify(status=status,msg=msg)

# get proposer and seconder to show table after select button
@app.route('/get_prosec/<int:society_id>/<string:society_key>', methods = ["GET", "POST"])
def get_prosec(society_id,society_key):
	ps_type       = request.form['type']
	reference_by  = request.form['user_id_refer']
	user_id       = request.form['user_id']
	members       = Reference().usp_get_reference_details(user_id,reference_by,ps_type)
	societyData   = Society().getSociety(society_id,society_key)
	return render_template('memberapp_users/prosec_two_table.html',members=members,type=ps_type,society_id=society_id,society_key=society_key,societyData=societyData)

# get exist proposer and seconder in db
@app.route('/get_exists_proandsec/<int:society_id>/<string:society_key>', methods = ["GET", "POST"])
def get_exists_proandsec(society_id,society_key):
	status      = 0
	html        = ""
	user_id     = request.form['user_id']
	ps_type     = request.form['type']
	member      = Users().get_already_pro_sec(user_id,ps_type)
	societyData = Society().getSociety(society_id,society_key)
	if member:
		status   = 1
		html     = render_template('memberapp_users/prosec_two_table.html',members = member,type=ps_type,society_id=society_id,society_key=society_key,societyData=societyData)
	return jsonify(status=status,html=html)

# delete proposer and seconder      
@app.route('/delete_prosec/<int:society_id>/<string:society_key>',methods = ["GET","POST"])
def Delete_prosec(society_id,society_key):
	reference_id = request.values['reference_id']
	Reference().delete_prosec(reference_id)
	return jsonify(status = "success")

@app.route('/other_society/<user_id>/<cur_step>/<pre_step>/<nxt_step>/<int:society_id>/<string:society_key>', methods = ["GET"])
@RouteGroup.login_required
@RouteGroup.society_required
def getOtherSociety(user_id,cur_step,pre_step,nxt_step,society_id,society_key):
	user_id     = unquote(user_id)
	user_id     = int(Cryptography.decrypt(user_id))
	userData    = Users().get_member(user_id)
	if not userData:
		flash("User Not Found","errorMsg")
		return redirect(url_for('member.getLogin',society_id=society_id,society_key=society_key))
	else:
		encrypt_user_id  = Cryptography.encrypt(int(user_id))
		return render_template('memberapp_users/membership_other_society.html',user_id=user_id,encrypt_user_id=encrypt_user_id,society_id=society_id,society_key=society_key,cur_step=cur_step,pre_step=pre_step,nxt_step=nxt_step)

@app.route('/other_society/<user_id>/<cur_step>/<pre_step>/<nxt_step>/<int:society_id>/<string:society_key>', methods = ["POST"])
@RouteGroup.society_required
def postOtherSociety(user_id,cur_step,pre_step,nxt_step,society_id,society_key):
	user_id             = unquote(user_id)
	user_id             = int(Cryptography.decrypt(user_id))
	count_othersociety  = UserOthersociety().count_othersociety_user_id(user_id)
	if count_othersociety['user_id'] < 1:
		flash("Please add other assocations/society details","errorMsg")
		encrypt_user_id  = Cryptography.encrypt(int(user_id))
		return redirect (url_for('member.getStep',user_id=encrypt_user_id,step_no=cur_step,society_id=society_id,society_key=society_key))
	else:
		status          = "step8"
		status_id_1     = MStatus().get_status_id(status,society_id)
#       status_id       = status_id_1.status_id
		data            = {'status_id':status_id_1.status_id,'updated_at': datetime.now()}
		userData        = Users().get_member(user_id)
#       member_type_id  = userData.member_type_id
		if userData.status_id != Auth.getSociety(society_id)['ms_rejected_status_id'] :
			Users().update_member(user_id,data)
		user_logs_data = {'society_id':society_id,'user_id' : user_id,'status_id': status_id_1.status_id,'status':status,'member_type_id':userData.member_type_id,'created_at':datetime.now()}
		UserStatusLogs().insert_status(user_logs_data)
		encrypt_user_id  = Cryptography.encrypt(int(user_id))
		return redirect (url_for('member.getStep',user_id=encrypt_user_id,step_no=nxt_step,society_id=society_id,society_key=society_key))
	
@app.route('/insert_other_society/<int:society_id>/<string:society_key>', methods = ["GET", "POST"])
def insertOtherSociety(society_id,society_key):
	if request.method == "POST":
		user_other_society_id   = request.form['user_other_society_id']
		user_id                 = request.form['user_id']
		other_society_name      = request.form['associations_society']
		other_membership_no     = request.form['other_membership_no']
		data = {
			'user_other_society_id'         : user_other_society_id,
			'user_id'                       : user_id,
			'other_society_name'            : other_society_name,
			'other_membership_no'           : other_membership_no,
			'created_at'                    : datetime.now(),
			'updated_at'                    : datetime.now(),
		}
		othersociety_data = UserOthersociety().update_or_insert_othersociety(user_id,user_other_society_id,data)  
		return render_template('memberapp_users/othersociety_table.html',data = othersociety_data,society_id=society_id,society_key=society_key)
		
@app.route('/get_othersociety_by_user/<int:society_id>/<string:society_key>',methods = ["GET","POST"])
def getOtherSocietyByUser(society_id,society_key):
	user_id = request.values["user_id"]
	data    = UserOthersociety().get_othersociety_by_user(user_id)
	return render_template('memberapp_users/othersociety_table.html',data = data,society_id=society_id,society_key=society_key)

#edit work
@app.route('/get_othersociety/<int:society_id>/<string:society_key>',methods = ["GET","POST"])
def getOtherSocietyMembership(society_id,society_key):
	user_other_society_id   = request.values['user_other_society_id']
	data                    = UserOthersociety().get_othersociety(user_other_society_id)
	return json.dumps(data)

@app.route('/delete_othersociety/<int:society_id>/<string:society_key>',methods = ["GET","POST"])
def deleteOtherSociety(society_id,society_key):
	user_other_society_id   = request.form['user_other_society_id']
	user_id                 = request.form['user_id']
	UserOthersociety().delete_othersociety(user_other_society_id)
	data                    = UserOthersociety().get_othersociety_by_user(user_id)
	return render_template('memberapp_users/othersociety_table.html',data = data,society_id=society_id,society_key=society_key)

# After payment completed in the dashboard click the view application button to view your information[BACK button]
@app.route('/view/<user_id>/<int:society_id>/<string:society_key>', methods = ["GET"])
def View(user_id,society_id,society_key):
	return Confirmation(user_id,society_id,society_key,0,1)

# proposer and seconder view the member who has consent for the membership application
@app.route('/viewmember/<old_user_id>', methods = ["GET"])
def ViewMember(old_user_id):
	society,msg         = Auth.checkSociety()
	old_user_id         = unquote(old_user_id)
	old_user_id         = int(Cryptography.decrypt(old_user_id))
	userData            = Users().get_member_old_user_id(old_user_id,society['society_id'])
	encrypt_user_id     = Cryptography.encrypt(int(userData.user_id))
	return Confirmation(encrypt_user_id,society['society_id'],society['society_key'],0,2)

@app.route('/viewmember_v1/<user_uuid>/<int:society_id>/<string:society_key>', methods = ["GET"])
@RouteGroup.society_required
def ViewMember_v1(user_uuid,society_id,society_key):
	society          = Auth.checkSocietybyIdKey(society_id,society_key)
	userData         = Users().get_user_uuid_data(user_uuid)
	encrypt_user_id  = Cryptography.encrypt(int(userData.user_id))
	return Confirmation(encrypt_user_id,society_id,society_key,0,2)

#view page with submit button
@app.route('/confirmation/<user_id>/<int:society_id>/<string:society_key>/<step_no>/<int:view_code>', methods = ["GET"])
@app.route('/confirmation/<user_id>/<int:society_id>/<string:society_key>/<step_no>', methods = ["GET"])
# @RouteGroup.login_required
@RouteGroup.society_required
def Confirmation(user_id,society_id,society_key,step_no,view_code = 0):
	user_id         = unquote(user_id)
	user_id         = int(Cryptography.decrypt(user_id))
	societyData     = Auth.getSociety(society_id)
	userData        = Users().get_member(user_id)
#   member_type_id  = userData.member_type_id
	memberData      = MMemberType().usp_get_member_display_name(user_id,society_id)
	member          = memberData[0]
	if userData.status_id < 10:
		status         = 'confirmation_page'
		status_id_1    = MStatus().get_status_id(status,society_id)
#       status_id      = status_id_1.status_id
		data           = {'status_id':status_id_1.status_id,'updated_at': datetime.now()}
		user_logs_data = {'society_id':society_id,'user_id' : user_id,'status_id': status_id_1.status_id,'status':status,'member_type_id':userData.member_type_id,'created_at':datetime.now()}
		UserStatusLogs().insert_status(user_logs_data)
		Users().update_member(user_id,data)
	else :
		pass
	userss = Users().AllUserData(user_id)
	for index,value in enumerate(userss) :
		if index == 0 :
			user_profile        = value[0]
		if index == 1 :
			user_qualification  = value         
		if index == 2 :
			user_work           = value   
		if index == 3 :
			user_attachments    = value 
		if index == 4 :
			prosec              = value 
		if index == 5 :
			othersociety        = value
		if index == 6 :
			user_training       = value
		if index == 7 :
			user_publication    = value

	encrypt_user_id  = Cryptography.encrypt(int(user_id))
	return render_template('memberapp_users/confirmation.html',user_id=user_id,datas=user_qualification,data=user_work,user=user_profile,image=user_attachments,prosec_data=prosec,view_code=view_code,encrypt_user_id=encrypt_user_id,member=member,othersociety=othersociety,user_training=user_training,society_id=society_id,society_key=society_key,step_no=step_no,societyData=societyData,user_publication=user_publication)

@app.route('/get_make_payment/<user_id>/<int:society_id>/<string:society_key>/<step_no>', methods = ["GET","POST"])
@RouteGroup.login_required
@RouteGroup.society_required
def getMakePayment(user_id,society_id,society_key,step_no):
	user_id          = unquote(user_id)
	user_id          = int(Cryptography.decrypt(user_id))
	userData         = Users().get_member(user_id)
	societyData      = Auth.getSociety(society_id)
	if societyData['member_approve_type'] == "before payment":
		encrypt_user_id  = Cryptography.encrypt(int(user_id))
		return redirect(url_for('member.RegSuccessMail',user_id=encrypt_user_id,society_id=society_id,society_key=society_key))
	else:
		is_visible       = 1
		is_membership    = 1
		payment_types    = MPaymentType().count_payment_type(is_visible,is_membership,society_id)
		if payment_types:
			payment          = payment_types[0]
			payment_id       = request.values.get('payment_id',0)
			payment_type     = payment['payment_type']
			m_payment_id     = payment['m_payment_id']
			if len(payment_types) == 1  :
				if payment_type == "Online Payment" : # online payment means payment gateway for VRSI,IPGS,APOTS
					encrypt_user_id  = Cryptography.encrypt(int(user_id))
					return redirect(url_for('member.Payment_v1',user_uuid=userData.user_uuid,society_id=society_id,society_key=society_key,step_no=step_no))
				else: # CSOS
					encrypt_user_id  = Cryptography.encrypt(int(user_id))
					return redirect(url_for('member.PostPayment',user_id=encrypt_user_id,payment_type=payment_type,payment_id=payment_id,m_payment_id=m_payment_id,society_id=society_id,society_key=society_key,step_no=step_no))
			
			# choose the payment type such as online transfer, online payment,...etc # MOS,TNOA
			else:
				memberData          = MMemberType().usp_get_member_display_name(user_id,society_id)
				member              = memberData[0]
				app_type            = Helper.AppType
				pay                 = UserPayment().get_already_payment(user_id,app_type)
				encrypt_user_id     = Cryptography.encrypt(int(user_id))
				return render_template('memberapp_users/make_payment.html',payment_type=payment_types,user_id=user_id,encrypt_user_id=encrypt_user_id,pay=pay,member=member,society_id=society_id,society_key=society_key,step_no=step_no)
		else:
			return "No Payment"

			
@app.route('/post_make_payment/<user_id>/<int:society_id>/<string:society_key>/<step_no>', methods = ["GET", "POST"])
@RouteGroup.login_required
@RouteGroup.society_required
def PostMakePayment(user_id,society_id,society_key,step_no):
	user_id     = unquote(user_id)
	user_id     = int(Cryptography.decrypt(user_id))
	societyData = Auth.getSociety(society_id)
	userData    = Users().get_member(user_id)
	if request.method == "POST":
		payment_id      = request.values['payment_id']
		payment_type    = request.form['payment_type']
		if payment_type == "Online Payment":
			encrypt_user_id  = Cryptography.encrypt(int(user_id))
			return redirect(url_for('member.Payment_v1',user_uuid=userData.user_uuid,society_id=society_id,society_key=society_key,step_no=step_no))
		else:
			now         = datetime.now()
			unique_id   = now.strftime('%Y%m%d%H%M%S%f')
			userData    = Users().get_member(user_id)
			memberData  = MMemberType().usp_get_member_display_name(user_id,society_id)
			member      = memberData[0]
			data={
				'user_id'       : user_id,
				'unique_id'     : unique_id,
				'amount'        : member['amount'],
				'created_at'    : datetime.now(),
				'payment_method': payment_type,
				'society_id'    : society_id,
				'app_type'      : Helper.AppType
			}
			if int(payment_id) > 0 :
				result     = UserPayment().update_payments_data(payment_id,user_id,data)
				utr_number = result.utr_number
			else:
				payment_id = UserPayment().insert_payment(data)
				payment_id = payment_id
				utr_number = None
			
			is_payment      = 1
			is_pg           = userData.is_pg
			if is_pg is not None:
				image     = MAttachmentType().get_image_pg(user_id,is_payment,is_pg,society_id)
			else:
				image     = MAttachmentType().get_image(user_id,is_payment,society_id)
			is_membership   = 1
			payment_content = MPaymentType().get_payment_content(payment_type,is_membership,society_id)
			encrypt_user_id = Cryptography.encrypt(int(user_id))
			return render_template('memberapp_users/make_payment_screen.html',user_id=user_id,payment_id=payment_id,image=image,encrypt_user_id=encrypt_user_id,unique_id=unique_id,payment_content=payment_content,payment_type=payment_type,member=member,society_id=society_id,society_key=society_key,step_no=step_no,utr_number=utr_number,userData=userData,societyData=societyData)
	else :
		flash("Please, Try again.","errorMsg")
		return redirect(url_for('member.getLogin',society_id=society_id,society_key=society_key))

@app.route('/postpayment/<user_id>/<payment_type>/<payment_id>/<m_payment_id>/<int:society_id>/<string:society_key>/<step_no>', methods = ["GET", "POST"])
@RouteGroup.login_required
@RouteGroup.society_required
def PostPayment(user_id,payment_type,payment_id,m_payment_id,society_id,society_key,step_no):
	user_id         = unquote(user_id)
	user_id         = int(Cryptography.decrypt(user_id))
	societyData     = Auth.getSociety(society_id)
	now             = datetime.now()
	unique_id       = now.strftime('%Y%m%d%H%M%S%f')
	userData        = Users().get_member(user_id)
	memberData      = MMemberType().usp_get_member_display_name(user_id,society_id)
	member          = memberData[0]
	data = {
		'user_id'       : user_id,
		'unique_id'     : unique_id,
		'currency'      : member['currency'],
		'amount'        : member['amount'],
		'society_id'    : society_id,
		'created_at'    : now.strftime("%Y-%m-%d %H:%M:%S"),
		'payment_method': payment_type,
		'app_type'      : Helper.AppType
	}
	if int(payment_id) > 0 :
		result      = UserPayment().update_payments_data(payment_id,user_id,data)
		utr_number  = result.utr_number
	else:
		payment_id = UserPayment().insert_payment(data)
		payment_id = payment_id
		utr_number = None
	is_payment        = 1
	is_visible        = 1
	is_membership     = 1
	if userData.is_pg is not None :
		image    = MAttachmentType().get_image_pg(user_id,is_payment,userData.is_pg,society_id)
	else:
		image    = MAttachmentType().get_image(user_id,is_payment,society_id)
	payment_content   = MPaymentType().get_payment_content_id(m_payment_id,is_membership,society_id)
	payment_types     = MPaymentType().count_payment_type(is_visible,is_membership,society_id)
	len_payment_types = len(payment_types)
	encrypt_user_id   = Cryptography.encrypt(int(user_id))
	return render_template('memberapp_users/make_payment_screen.html',user_id=user_id,payment_id=payment_id,image=image,encrypt_user_id=encrypt_user_id,unique_id=unique_id,payment_content=payment_content,len_payment_types=len_payment_types,society_id=society_id,society_key=society_key,step_no=step_no,utr_number=utr_number,userData=userData,societyData=societyData)

# VRSI and IPGS and APOTS have only online payment 
##################### PayUMoney payment for VRSI ########################################
@app.route('/payment/<old_user_id>', methods = ["GET", "POST"])
def Payment(old_user_id):
	society,msg         = Auth.checkSociety()
	old_user_id         = unquote(old_user_id)
	old_user_id         = int(Cryptography.decrypt(old_user_id))
	userData            = Users().get_member_old_user_id(old_user_id,society['society_id'])
	if userData.status_id == society['ms_approved_status_id']:
		flash("Already your payment completed, your membership number generated and sent to your mail.","successMsg")
		encrypt_user_id     = Cryptography.encrypt(int(user_id))
		return render_template("memberapp_users/display_msg.html",user_id=encrypt_user_id,society_id=society['society_id'],society_key=society['society_key'])
	else:
		now         = datetime.now()
		dt_string   = now.strftime('%Y-%m-%d %H:%M:%S')
		unique_id   = now.strftime('%Y%m%d%H%M%S%f')
		is_test     = society['paymentgateway_is_test']
		am_id       = society['paymentgateway_appmaster_id']  # for payumoney account test account given by Ganesan on Feb 16 2022 
		# for instamojo am_id = 4 ,for Razorpay am_id = 1 ,Payumoney =2
		url         = society['paymentgateway_api_url']+'api_key'
		r           = requests.get(url)
		apikey      = json.loads(r.content.decode())
		am_id       = int(am_id)
		for index,value in enumerate(apikey) :
			api_am_id = value['am_id']
			if api_am_id == am_id :
				app_key  = value['app_key']
				app_name = value['app_name']
				break
			else :
				pass
		payment_for         = app_name  
		unique_id           = app_key+"_"+unique_id
		remarks             = society['society_intial']+ " membership registration"
		app_type            = Helper.AppType
		insertPaymentData   = UserPayment().insertPaymentData(userData.user_id,society['society_id'],am_id,unique_id,is_test,dt_string,payment_for,remarks,app_type)
		encrypt_user_id     = Cryptography.encrypt(int(userData.user_id))
		return redirect(url_for('member.CallPayment',user_id=encrypt_user_id,unique_id=unique_id,society_id=society['society_id'],society_key=society['society_key'],step_no=7))

@app.route('/payment_v1/<user_uuid>/<int:society_id>/<string:society_key>/<step_no>', methods = ["GET", "POST"])
def Payment_v1(user_uuid,society_id,society_key,step_no):
	society             = Auth.checkSocietybyIdKey(society_id,society_key)
	userData            = Users().get_user_uuid_data(user_uuid)
	if society['paymentgateway_appmaster_id'] is  None:
		return "No Online Payment"
	else:
		if userData.status_id == society['ms_approved_status_id']:
			flash("Already your payment completed, your membership number generated and sent to your mail.","successMsg")
			encrypt_user_id     = Cryptography.encrypt(int(userData.user_id))
			return render_template("memberapp_users/display_msg.html",user_id=encrypt_user_id,society_id=society_id,society_key=society_key)
		else:
			now         = datetime.now()
			dt_string   = now.strftime('%Y-%m-%d %H:%M:%S')
			unique_id   = now.strftime('%Y%m%d%H%M%S%f')
			is_test     = society['paymentgateway_is_test']
			am_id       = society['paymentgateway_appmaster_id']  # for payumoney account test account given by Ganesan on Feb 16 2022 
			url         = society['paymentgateway_api_url']+'api_key'
			# print("api url :",url)
			r           = requests.get(url)
			apikey      = json.loads(r.content.decode())
			am_id       = int(am_id)
			for index,value in enumerate(apikey) :
				api_am_id = value['am_id']
				if api_am_id == am_id :
					app_key  = value['app_key']
					app_name = value['app_name']
					break
				else :
					pass
			payment_for = app_name 
			if int(society_id) == 4:
				app_key  =  "IPGSMEM22"
			else:
				pass

			unique_id           = app_key+"_"+unique_id
			remarks             = society['society_intial']+ " membership registration"
			app_type            = Helper.AppType
			insertPaymentData   = UserPayment().insertPaymentData(userData.user_id,society_id,am_id,unique_id,is_test,dt_string,payment_for,remarks,app_type)
			encrypt_user_id     = Cryptography.encrypt(int(userData.user_id))
			return redirect(url_for('member.CallPayment',user_id=encrypt_user_id,unique_id=unique_id,society_id=society_id,society_key=society_key,step_no=step_no))

@app.route('/call_payment/<user_id>/<unique_id>/<int:society_id>/<string:society_key>/<step_no>', methods = ["GET", "POST"])
@RouteGroup.society_required
def CallPayment(user_id,unique_id,society_id,society_key,step_no):
	user_id     = unquote(user_id)
	user_id     = int(Cryptography.decrypt(user_id))
	societyData = Auth.getSociety(society_id)
	getData     = UserPayment().getDataforPayments(user_id,unique_id,society_id)
	step_no_data = MSteps().getlastStepNo(society_id)
	last_step_no = None
	if step_no_data:
		last_step_no = step_no_data.step_no  
	if getData :
		getData         = getData[0]
		am_id           = getData['am_id']
		# gateway_id = base64.b64encode(bytes(gateway_id, 'utf-8'))
		sample_string       = str(am_id)
		sample_string_bytes = sample_string.encode("ascii")
		base64_bytes        = base64.b64encode(sample_string_bytes)
		am_id_base64        = base64_bytes.decode("ascii")
		getData['res_url']  = request.host_url+"payment_server_response/"+str(society_id)+'/'+str(society_key)  + ('/'+ str(last_step_no) if last_step_no else '') 
		getData['remarks']  = societyData['society_intial']+ " membership registration"
		if  int(society_id) == 4 and "IPGSMEM22" in unique_id:
			url_1 = "https://ccavenue-payment.ipgs.org.in/?name="+str(getData['full_name'])+"&email="+getData['email']+"&mobile="+getData['mobile']+"&unique_id="+getData['unique_id']+"&amount="+str(getData['amount'])+"&res_url=https://ipgs.org.in"
			return  flask.redirect(url_1)
			
		elif  int(society_id) == 10 and "KOS" in unique_id:
			url_1 = "https://kosonline.org/paymentapi_mem/payment_screen.html?name="+str(getData['full_name'])+"&email="+getData['email']+"&mobile="+getData['mobile']+"&unique_id="+getData['unique_id']+"&amount="+str(getData['amount'])+"&res_url=https://membership.numerotech.com"
# 			print(url_1)
			return  flask.redirect(url_1)   
			
		elif  int(society_id) == 18 and "KSOS" in unique_id:
			step_no = 5
			url_1 = "https://ksos.in/paymentapi_mem/payment_screen.html?name="+str(getData['full_name'])+"&email="+getData['email']+"&mobile="+getData['mobile']+"&unique_id="+getData['unique_id']+"&amount="+str(getData['amount'])+"&city="+str(getData['city'])+"&pincode="+str(getData['pincode'])+"&state="+str(getData['state_name'])+"&res_url=https://membership.ksos.in/payment_server_response/"+str(society_id)+"/"+society_key+"/"+str(step_no)
			return  flask.redirect(url_1)
			
		elif  int(society_id) == 3:
			return render_template("memberapp_users/call_payment_screen_tnoa.html" ,data= getData,am_id_base64 =am_id_base64,user_id=user_id,society_id=society_id,society_key=society_key,step_no=step_no)
			
		else:
			return render_template("memberapp_users/call_payment_screen.html" ,data= getData,am_id_base64 =am_id_base64,user_id=user_id,society_id=society_id,society_key=society_key,step_no=step_no)
	else :
		flash("Please, Try again.","errorMsg")
		return redirect(url_for('member.getLogin',society_id=society_id,society_key=society_key))

@app.route('/payment_server_response/<int:society_id>/<string:society_key>', methods = ["GET", "POST"])
@app.route('/payment_server_response/<int:society_id>/<string:society_key>/<step_no>', methods = ["GET", "POST"])
def PaymentServerResponse(society_id,society_key,step_no=None):
	society         = Auth.checkSocietybyIdKey(society_id,society_key)
	api_payment_id  = request.values.get('payment_id') or None
	status          = request.values.get('status') or None
	email           = request.values.get('email') or None
	mobile          = request.values.get('mobile') or None
	unique_id       = request.values.get('unique_id') or None #['3343434']
	payment_method  = request.values.get('method') or None
	step_no         = step_no if step_no else (request.values.get('step_no') or 7)
	
	if payment_method is not None :
		payment_method = "PG - "+payment_method
	else:
		payment_method = None
	result          = UserPayment().get_payment_unique(society_id,unique_id)
	if result is None:
		flash("User Not Found","errorMsg")
		return redirect(url_for('member.getLogin',society_id=society_id,society_key=society_key))
	else:
		user_id        = result['user_id']
		payment_id     = result['payment_id']
		member_type_id = result['member_type_id']
		payment_status = result['status']
		
#   Log().insert({'url':request.url,'level':'INFO'})        
	if result['membership_no'] :
		flash('Already your membership number generated and confirmation mail sent to your registered email id')
		encrypt_user_id  = Cryptography.encrypt(int(user_id))
		return render_template("memberapp_users/display_msg.html",user_id=encrypt_user_id,society_id=society_id,society_key=society_key)

	else:
		if payment_id is  None:
			flash("User Not Found","errorMsg")
			return redirect(url_for('member.getLogin',society_id=society_id,society_key=society_key))
		else:
			 # update payment status in your table
			if status and status == "success" :
				data             = {'api_payment_id' : api_payment_id,'status':status,'updated_at' :datetime.now(),'paid_at':datetime.now(),'payment_method':payment_method}
				UserPayment().updatePayment(unique_id,data)
				encrypt_user_id  = Cryptography.encrypt(int(user_id))
				if society['member_approve_type'] == "before payment":
					member_type_id = result['approved_member_type_id']
					Users().usp_generate_membership_number(user_id,member_type_id,society_id)
					status      = "approved"
					status_id_1 = MStatus().get_status_id(status,society_id)
					status_id   = status_id_1.status_id
					data        = {'status_id': status_id,'updated_at':datetime.now()}
					Users().update_member(user_id,data)
					userData     = Users().get_member(user_id)
					member_type_id= userData.member_type_id
					user_logs_data = {'society_id':society_id,'user_id' : user_id,'status_id': status_id,'status':status,'member_type_id':member_type_id,'created_at':datetime.now()}
					UserStatusLogs().insert_status(user_logs_data)
					return redirect(url_for('member.PaymentSuccessMail',user_id=encrypt_user_id,society_id=society_id,society_key=society_key))
				else:
					status      = "payment completed"
					status_id_1 = MStatus().get_status_id(status,society_id)
					status_id   = status_id_1.status_id
					data        = {'status_id': status_id,'updated_at':datetime.now()}
					Users().update_member(user_id,data)
					userData     = Users().get_member(user_id)
					member_type_id= userData.member_type_id
					user_logs_data = {'society_id':society_id,'user_id' : user_id,'status_id': status_id,'status':status,'member_type_id':member_type_id,'created_at':datetime.now()}
					UserStatusLogs().insert_status(user_logs_data)
					return redirect(url_for('member.RegSuccessMail',user_id = encrypt_user_id,society_id=society_id,society_key=society_key))
			else:
				data = {'status':status,'updated_at' :datetime.now()}
				UserPayment().updatePayment(unique_id,data)
				if society['member_approve_type'] == "before payment":
					flash( result['prefix']+result['full_name']+", Your payment has failed. Please try again","errorMsg")
					encrypt_user_id  = Cryptography.encrypt(int(user_id))
					return render_template("memberapp_users/display_msg.html",user_id=encrypt_user_id,society_id=society_id,society_key=society_key)
				else:
					flash("Payment failure. Please try to make payment again","errorMsg")
					encrypt_user_id  = Cryptography.encrypt(int(user_id))
					return Confirmation(user_id = encrypt_user_id,society_id=society_id,society_key=society_key,step_no=step_no)            

@app.route('/check_pending_payment_response', methods = ["GET", "POST"])
def CheckPendingPayementResponse():
	try:
		update_count = 0
		unique_ids_1 = ""
		society      = Society().setSociety(request.host)
		if society:
			society_id = society['society_id']
			society_key = society['society_key']
		else:
			society_id  = 1
			society_key = 'vrsi'
			society   = Society().getSociety(society_id,society_key)
		app_type  = Helper.AppType
		now       = datetime.now()
		cur_date  = now.strftime("%Y-%m-%d")
		paymentDatas = UserPayment().get_unique_id(society_id,app_type,cur_date)
		if paymentDatas:
			l_unique_ids =[]
			for paymentData in paymentDatas:
				l_unique_ids.append(paymentData['unique_id'])
				unique_ids = ",".join(l_unique_ids) 
			url = 'https://paymentapi.numerotech.com/payment_response_by_unique_id?unique_ids='+str(unique_ids)
			r   = requests.get(url)
			response_1 = json.loads(r.content.decode())
			if response_1['status'] == 1 : 
				for payment_data in response_1['payment_data']:
					payment_status = payment_data['payment_status']
					if payment_status and  'success' in payment_status :
						api_payment_id  = payment_data['payment_id']
						payment_method  = payment_data['method']
						is_webhook_update = payment_data['is_webhook_update']
						data            = {'api_payment_id' : api_payment_id,'status':payment_status,'updated_at' :datetime.now(),'paid_at':datetime.now(),'payment_method':payment_method,'is_webhook_update':is_webhook_update}
						unique_id       = payment_data['unique_id']
						update_count    = update_count + 1
						unique_ids_1    = unique_ids_1+ " , " + unique_id
						userData        = UserPayment().updatePayment(unique_id,data)
						user_id         = userData.user_id
						encrypt_user_id = Cryptography.encrypt(int(user_id))
						if society['member_approve_type'] == "before payment":
							Users().usp_generate_membership_number(user_id,userData.member_type_id,society_id)
							status      = "approved"
							status_id_1 = MStatus().get_status_id(status,society_id)
							data        = {'status_id': status_id_1.status_id,'updated_at':datetime.now()}
							Users().update_member(user_id,data)
							PaymentSuccessMail(user_id=encrypt_user_id,society_id=society_id,society_key=society_key,society=society)
						
						else:
							pass

					else:
						pass
				if update_count >0:
					return str(unique_ids_1)+ " these unique ids records are updated in payment table ."
				else:
					return "Payment success data not exist in PayUMoney"    

			else:
				return "unique id not match"
		else:
			return "No Data"
				
	except Exception as e:
		return str(e)

@app.route('/pay_success_mail/<user_id>/<int:society_id>/<string:society_key>', methods = ["GET","POST"])
@RouteGroup.society_required
def PaymentSuccessMail(user_id,society_id,society_key):
	user_id          = unquote(user_id)
	user_id          = int(Cryptography.decrypt(user_id))
	societyData      = Auth.getSociety(society_id)
	if societyData :
		app_type         = Helper.AppType
		userData         = MMemberType().get_member_type_name(user_id,app_type)
		full_name        = userData['prefix']+userData['full_name'] if userData['prefix'] else userData['full_name']
		template_name    = "pay_success_mail"
		mailData         = MembershipMailTemplates().get_mail_template(society_id,template_name)
		sub_data         = { 'full_name' : full_name,'society_name': societyData['society_intial']}
		subject          = Helper.merge_tags(mailData.subject,sub_data)
		email            = userData['email']
		encrypt_user_id  = Cryptography.encrypt(int(user_id))
		society  = {
			'society_id'   : society_id,
			'society_key'  : society_key,
			'society_name' : societyData['society_intial'],
			'support_mail' : societyData['e_support_mail'],
			'base_url'     : Helper.base_url()
		}
		data = {
			'mail_content' : mailData.mail_content,
			'userData'     : userData,
			'society'      : society
		}
		mail_content     = Helper.convert_html_for_mail_screen(data)
		html             = render_template('memberapp_users/email/mail_template.html',mail_content=mail_content,society_id=society_id,society_key=society_key)
		EMAIL.sendMail(subject,html,email,mailData,societyData)
		# receipt mail
		if int(society_id) == 4 :
			r_template_name  = "receipt_mail"
			r_mailData       = MembershipMailTemplates().get_mail_template(society_id,r_template_name)
			r_sub_data       = {'receipt_no':str(userData['membership_no_only']),'amount':str(userData['amount'])}
			r_subject        = Helper.merge_tags(r_mailData.subject,r_sub_data)
			r_data = {
				'mail_content' : r_mailData.mail_content,
				'userData'     : userData,
				'society'      : society
			}
			r_mail_content   = Helper.convert_html_for_mail_screen(r_data)
			r_html           = render_template('memberapp_users/email/mail_template.html',mail_content=r_mail_content,society_id=society_id,society_key=society_key)
			# return r_html
			EMAIL.sendMail(r_subject,r_html,email,r_mailData,societyData)
		else:
			pass

		flash(userData['prefix']+userData['full_name']+", Your payment Rs."+str(userData['amount'])+"/- is successfully transferred and Your membership number generated sent to your mail.","successMsg")
		return render_template("memberapp_users/display_msg.html",user_id=encrypt_user_id,society_id=society_id,society_key=society_key)
	else:
		encrypt_user_id  = Cryptography.encrypt(int(user_id))
		flash("Your session has expired. Please try again.","errorMsg")
		return render_template("memberapp_users/display_msg.html",user_id=encrypt_user_id,society_id=society_id,society_key=society_key)

@app.route('/non_payment_response/<user_id>/<unique_id>/<m_payment_id>/<int:society_id>/<string:society_key>/<step_no>', methods = ["GET", "POST"])
@RouteGroup.society_required
def nonPaymentResponse(user_id,unique_id,m_payment_id,society_id,society_key,step_no):
	user_id      = unquote(user_id)
	user_id      = int(Cryptography.decrypt(user_id))
	societyData  = Auth.getSociety(society_id)
	is_payment   = 1 # 1 is with payment screen and 0 is without payment screen and none is both 
	userData     = Users().get_member(user_id)
	memberData   = MMemberType().usp_get_member_display_name(user_id,society_id)
	member       = memberData[0]
	if userData.is_pg is not None :
		image  = MAttachmentType().get_image_pg(user_id,is_payment,userData.is_pg,society_id)
	else:
		image  = MAttachmentType().get_image(user_id,is_payment,society_id)
	is_membership       = 1
	payment_content     = MPaymentType().get_payment_content_id(m_payment_id,is_membership,society_id)
	is_visible          = 1
	payment_types       = MPaymentType().count_payment_type(is_visible,is_membership,society_id)
	len_payment_types   = len(payment_types)
	email               = userData.email
	result              = UserPayment().get_payment_unique(society_id,unique_id)
	required_at         = []
	for d in image :
		if d['attach_file_name'] == None  and d['is_mandatory'] == 1:
			required_at.append(d['attach_type'])
		if len(required_at) > 0:    
			flash("Please upload the proof of payment before proceeding further","errorMsg")
			encrypt_user_id  = Cryptography.encrypt(int(user_id))
			return render_template('memberapp_users/make_payment_screen.html',user_id=user_id,image=image,encrypt_user_id=encrypt_user_id,unique_id=unique_id,payment_content=payment_content,payment_id=result['payment_id'],payment_type=result['payment_method'],member=member,society_id=society_id,society_key=society_key,len_payment_types=len_payment_types,step_no=step_no,utr_number=result['utr_number'],userData=userData,societyData=societyData)
		else:
			status      = "success"
			if result is None:
				flash("User Not Found","errorMsg")
				return redirect(url_for('member.getLogin',society_id=society_id,society_key=society_key))
			else:
				user_id     = result['user_id']
				payment_id  = result['payment_id']
			if payment_id is  None:
				flash("User Not Found","errorMsg")
				return redirect(url_for('member.getLogin',society_id=society_id,society_key=society_key))
			else:
				now            = datetime.now()
				dt_string      = now.strftime('%Y-%m-%d %H:%M:%S')
				remarks        = societyData['society_intial']+ " membership registration"
				utr_number     = request.values.get('utr_number') or None
				paymentData    = {'status':status,'updated_at' :dt_string,'paid_at':dt_string,'remarks':remarks,'utr_number':utr_number}
				UserPayment().updatePayment(unique_id,paymentData) # update payment status in your table
				encrypt_user_id  = Cryptography.encrypt(int(user_id))
				if userData.status_id == societyData['ms_rejected_status_id']:
					return SubmitReupdate(encrypt_user_id,society_id,society_key)
				else:
					status         = "payment completed"
					status_id_1    = MStatus().get_status_id(status,society_id)
					data           = {'submit_on': datetime.now(),'updated_at':datetime.now(),'status_id':status_id_1.status_id}
					user_logs_data = {'society_id':society_id,'user_id' : user_id,'status_id': status_id_1.status_id,'status':status,'member_type_id':userData.member_type_id,'created_at':datetime.now()}
					UserStatusLogs().insert_status(user_logs_data)
					Users().update_member(user_id,data)
					return RegSuccessMail(encrypt_user_id,society_id=society_id,society_key=society_key)

#After payment
#Registration success mail to member
@app.route('/reg_success_mail/<user_id>/<int:society_id>/<string:society_key>', methods = ["GET","POST"])
@RouteGroup.society_required
def RegSuccessMail(user_id,society_id,society_key):
	user_id     = unquote(user_id)
	user_id     = int(Cryptography.decrypt(user_id))
	societyData = Auth.getSociety(society_id)
	userss      = Users().AllUserData(user_id)
	for index,value in enumerate(userss) :
		if index == 0 :
			user_profile        = value[0]
		if index == 1 :
			user_qualification  = value         
		if index == 2 :
			user_work           = value   
		if index == 3 :
			user_attachments    = value 
		if index == 4 :
			prosec              = value
		if index == 5 :
			othersociety        = value
		if index == 6 :
			user_training       = value

	template_name    = "reg_success_mail"
	mailData         = MembershipMailTemplates().get_mail_template(society_id,template_name)
	full_name        = user_profile['prefix']+user_profile['full_name'] if user_profile['prefix'] else user_profile['full_name'] 
	sub_data         = {'full_name'    : full_name,'society_name' : societyData['society_intial']}
	subject          = Helper.merge_tags(mailData.subject,sub_data)
	society     = {
		'society_id'          : society_id,
		'society_key'         : society_key,
		'society_name'        : societyData['society_intial'],
		'support_mail'        : societyData['e_support_mail'],
		'society_full_form'   : societyData['society_title'],
		'society_member_link' : societyData['society_url'],
		'base_url'            : Helper.base_url()
	}
	data = {
		'mail_content'       : mailData.mail_content,
		'userData'           : user_profile,
		'qul_data'           : user_qualification,
		'exp_data'           : user_work,
		'image'              : user_attachments,
		'prosec_data'        : prosec,
		'othersociety_data'  : othersociety,
		'training_data'      : user_training,
		'society'            : society
	}
	mail_content     = Helper.convert_html_for_mail_screen(data)
	html             = render_template('memberapp_users/email/mail_template.html',mail_content=mail_content,society_id=society_id,society_key=society_key)
	to               = user_profile['email']
	EMAIL.sendMail(subject,html,to,mailData,societyData)
	
	# send mail to proposer
	prop_data = prosec[0]
	sec_data  = prosec[1]
	pro_email = prop_data['email']
	sec_email = sec_data['email']
	template_name_1    = "proposer_mail"
	mailData_1         = MembershipMailTemplates().get_mail_template(society_id,template_name_1) 
	subject            = Helper.merge_tags(mailData_1.subject,sub_data)
	data_1 = {
		'mail_content'       : mailData_1.mail_content,
		'userData'           : user_profile,
		'prosec_data'        : prop_data,
		'society'            : society
	}
	mail_content     = Helper.convert_html_for_mail_screen(data_1)
	encrypt_user_id  = Cryptography.encrypt(int(user_id))
	prop_html        = render_template('memberapp_users/email/mail_template.html',mail_content=mail_content,society_id=society_id,society_key=society_key)
	EMAIL.sendMail(subject,prop_html,pro_email,mailData,societyData)
	
	# # send mail to seconder
	template_name_2    = "seconder_mail"
	mailData_2         = MembershipMailTemplates().get_mail_template(society_id,template_name_2)
	data_2 = {
		'mail_content'       : mailData_2.mail_content,
		'userData'           : user_profile,
		'prosec_data'        : sec_data,
		'society'            : society
	}
	mail_content     = Helper.convert_html_for_mail_screen(data_2)
	encrypt_user_id  = Cryptography.encrypt(int(user_id))
	sec_html         = render_template('memberapp_users/email/mail_template.html',mail_content=mail_content,society_id=society_id,society_key=society_key)
	EMAIL.sendMail(subject,sec_html,sec_email,mailData,societyData)
	if societyData['member_approve_type'] == "before payment":
		status          = "submitted"
		status_id_1     = MStatus().get_status_id(status,society_id)
		updatedata      = {'submit_on': datetime.now(),'updated_at':datetime.now(),'status_id':status_id_1.status_id}
		referenceData   = {'next_reminder_date':datetime.now() + timedelta(days=3),'updated_at':datetime.now()}
		user_logs_data  = {'society_id':society_id,'user_id' : user_id,'status_id': status_id_1.status_id,'status':status,'member_type_id':user_profile['member_type_id'],'created_at':datetime.now()}
		UserStatusLogs().insert_status(user_logs_data)
		Reference().update_reminder_prosec(user_id,referenceData)
		Users().update_member(user_id,updatedata)
		flash("""<h1 style=color:green;text-align:center;>You have completed filling up the application.</h1><br>
		Your application has been emailed to the proposer and seconder for their consent. Once the proposer and seconder has accepted your application, your application shall be auto-forwarded to the secretariat for further process.
		You may personally send reminders to your proposer and seconder to do the approve your application.<br><br>
		The secretariat shall review your application and shall either "Approve" your application or may "Reject" the same based on the eligibility criteria and the documents submitted.<br><br>
		Typically, it would take 7 working days by the secretariat for processing your application after the approval of proposer and seconder.<br><br>
		If your application is approved, you will get an email notifying the approval along with a link to make the payment.  You are expected to make the membership application fee within 15 days from the date of approval of the application.<br><br>
		Membership fee can be made only through the link sent to you.  Once you make the payment, your membership number shall be auto-generated and you will be notified by an email.<br><br>
		Your membership is subject to ratification in the subsequent General Body Meeting of """+societyData['society_intial']+""".<br><br>
		If your membership application is rejected, you will be notified about the same by email.  The email shall contain the reason for rejection of application.  You may login again and resubmit the application after making necessary changes in the form.<br>""","successMsg")
	else:
		flash("<h1 style=color:green;>Your application has been submitted</h1><br>Your application has been emailed to the proposer and seconder for their consent. Once the proposer and seconder has accepted your application,  your application shall be auto-forwarded to the secretariat for further process."
				"Typically, it would take 7 working days for processing your application.","successMsg")
	encrypt_user_id  = Cryptography.encrypt(int(user_id))
	return redirect(url_for('member.Dashboard',user_id=encrypt_user_id,society_id=society_id,society_key=society_key))
	
# redirect to dashboard page
@app.route('/dashboard/<user_id>/<int:society_id>/<string:society_key>', methods = ["GET","POST"])
@RouteGroup.login_required
@RouteGroup.society_required
def Dashboard(user_id,society_id,society_key):
	user_id              = unquote(user_id)
	user_id              = int(Cryptography.decrypt(user_id))
	societyData          = Auth.getSociety(society_id)
	cur_date_time        = datetime.now()
	cur_date_time_plus   = cur_date_time-timedelta(hours=1)
	app_type             = Helper.AppType
	datas                = Users().usp_data_for_dashboard(user_id)
	payment_status         = UserPayment().get_previou_payment(user_id,app_type,cur_date_time,cur_date_time_plus)
	if payment_status:
		payment_status         = list(payment_status)[-1]
	if datas is None:
		flash("User Not Found","errorMsg")
		return redirect(url_for('member.getLogin',society_id=society_id,society_key=society_key))
	else:
		userData    = datas[0]
		status_id   = userData['status_id']
		if status_id == societyData['ms_rejected_status_id']:
			remarks = UserStatusLogs().get_remarks(user_id,status_id)
		else:
			remarks = ''
		if  userData['status_id'] and userData['status_id'] >= 10:
			if userData['status_id']==14:
				userss = Users().AllUserData(user_id)
				for index,value in enumerate(userss) :
					if index == 0 :
						user_profile        = value[0]
						
					if index == 1 :
						user_qualification  = value         
					if index == 2 :
						user_work           = value   
					if index == 3 :
						user_attachments    = value 
					if index == 4 :
						prosec              = value 
					if index == 5 :
						othersociety        = value
					if index == 6 :
						user_training       = value
					if index == 7 :
						user_publication    = value
				encrypt_user_id  = Cryptography.encrypt(int(user_id))
				return render_template('memberapp_users/member_dashboard.html',encrypt_user_id =encrypt_user_id ,userData=userData,datas=user_qualification,data=user_work,user=user_profile,image=user_attachments,prosec_data=prosec,othersociety=othersociety,user_training=user_training,user_publication=user_publication,user_id=user_id,society_id=society_id,society_key=society_key,remarks=remarks,societyData=societyData)
			else:
				encrypt_user_id  = Cryptography.encrypt(int(user_id))
				return render_template('memberapp_users/dashboard.html',encrypt_user_id =encrypt_user_id ,payment_status=payment_status,user=userData,user_id=user_id,society_id=society_id,society_key=society_key,remarks=remarks,societyData=societyData)
		else :
			users            = Users().getUserByID(user_id)
			encrypt_user_id  = Cryptography.encrypt(int(user_id))
			bo_access = Users().check_bo_access(users['email'],1,society_id,None)
			users["is_admin"] =  bo_access["is_admin"]
			Auth.login(users,society_id) 
			return redirect(url_for('member.mailValidating',user_id=encrypt_user_id,society_id=society_id,society_key=society_key))

@app.route('/changes_prosec_mail/<user_id>/<ps_type>/<int:society_id>/<string:society_key>', methods = ["GET"])
@RouteGroup.society_required
def ChangesProsecMail(user_id,ps_type,society_id,society_key):
	user_id         = unquote(user_id)
	user_id         = int(Cryptography.decrypt(user_id))
	societyData     = Auth.getSociety(society_id)
	user_profile    = Users().get_member(user_id)
	member          = Users().get_changes_pro_sec(user_id,ps_type)
	email           = member['email']
	if ps_type == "proposer":
		template_name    = "proposer_mail"
	else:
		template_name    = "seconder_mail"
	mailData        = MembershipMailTemplates().get_mail_template(society_id,template_name) 
	full_name       = user_profile.prefix+user_profile.full_name if user_profile.prefix else user_profile.full_name
	sub_data        = {'full_name'    : full_name,'society_name' : societyData['society_intial']}
	society  = {
		'society_id'          : society_id,
		'society_key'         : society_key,
		'society_name'        : societyData['society_intial'],
		'support_mail'        : societyData['e_support_mail'],
		'society_full_form'   : societyData['society_title'],
		'society_member_link' : societyData['society_url'],
		'base_url'            : Helper.base_url()
	}
	data = {
		'mail_content' : mailData.mail_content,
		'userData'     : user_profile,
		'prosec_data'  : member,
		'society'      : society
	}
	subject          = Helper.merge_tags(mailData.subject,sub_data)
	mail_content     = Helper.convert_html_for_mail_screen(data)
	html             = render_template('memberapp_users/email/mail_template.html',mail_content=mail_content,society_id=society_id,society_key=society_key)
	EMAIL.sendMail(subject,html,email,mailData,societyData)
	flash("Your application has been emailed to the "+ps_type+" for their consent. Once the "+ps_type+" has accepted your application,  your application shall be auto-forwarded to the secretariat for further process."
				"Typically, it would take 7 working days for processing your application.","successMsg")
	encrypt_user_id  = Cryptography.encrypt(int(user_id))
	return redirect(url_for('member.Dashboard',user_id=encrypt_user_id,society_id=society_id,society_key=society_key))

@app.route('/reminder_mail/<user_id>/<ps_type>/<int:society_id>/<string:society_key>', methods = ["GET"])
@RouteGroup.society_required
def ReminderMail(user_id,ps_type,society_id,society_key):
	user_id         = unquote(user_id)
	user_id         = int(Cryptography.decrypt(user_id))
	societyData     = Auth.getSociety(society_id)
	if societyData:
		user_profile    = Users().get_member(user_id)
		member          = Users().get_changes_pro_sec(user_id,ps_type)
		email           = member['email']
		if ps_type == "proposer": 
			template_name    = "proposer_mail"
		else:
			template_name    = "seconder_mail"
		mailData        = MembershipMailTemplates().get_mail_template(society_id,template_name) 
		full_name       = user_profile.prefix+user_profile.full_name if user_profile.prefix else user_profile.full_name 
		sub_data        = { 'full_name'    : full_name,'society_name' : societyData['society_intial']}
		society = {
			'society_id'          : society_id,
			'society_key'         : society_key,
			'society_name'        : societyData['society_intial'],
			'support_mail'        : societyData['e_support_mail'],
			'society_full_form'   : societyData['society_title'],
			'society_member_link' : societyData['society_url'],
			'base_url'            : Helper.base_url()
		}
		data = {
			'mail_content' : mailData.mail_content,
			'userData'     : user_profile,
			'prosec_data'  : member,
			'society'      : society
		}
		subject          = Helper.merge_tags(mailData.subject,sub_data)
		subject          = "Reminder : "+subject
		mail_content     = Helper.convert_html_for_mail_screen(data)
		html             = render_template('memberapp_users/email/mail_template.html',mail_content=mail_content,society_id=society_id,society_key=society_key)
		EMAIL.sendMail(subject,html,email,mailData,societyData)
		flash("Reminder mail sent to "+ps_type,"successMsg")    
		encrypt_user_id  = Cryptography.encrypt(int(user_id))
		return redirect(url_for('member.Dashboard',user_id=encrypt_user_id,society_id=society_id,society_key=society_key))
	else:
		flash("Your session has expired. Please try again.","errorMsg")
		return redirect(url_for('member.getLogin',society_id=society_id,society_key=society_key))

# reference proposer and seconder
@app.route('/reference/<old_user_id>/<int:reference_by>/<ps_type>', methods = ["GET","POST"])
def reference(old_user_id,reference_by,ps_type):
	society,msg   = Auth.checkSociety()
	old_user_id   = unquote(old_user_id)
	try:
		old_user_id  = int(Cryptography.decrypt(old_user_id))
	except:
		flash("Invalid URL","errorMsg")
		return render_template('memberapp_users/display_msg.html')
	user_reference  = Reference().usp_get_reference(old_user_id,reference_by)
	userData        = Users().get_member_old_user_id(old_user_id,society["society_id"])
	encrypt_user_id = Cryptography.encrypt(int(userData.user_id))
	prefix_name     = userData.prefix+userData.full_name if userData.prefix else userData.full_name     
	if user_reference is None:
		flash("You cannot provide your response, "+prefix_name+" has changed the "+ps_type+".","errorMsg")
		return render_template('memberapp_users/display_msg.html')
	else:
		user = user_reference[0]
		return render_template('memberapp_users/reference_prosec.html',user_id=userData.user_id,reference_by=user['reference_by'],pro=user,encrypt_user_id=encrypt_user_id,society_id=society["society_id"],society_key=society["society_key"])
			
@app.route('/reference_v1/<user_uuid>/<reference_user_uuid>/<ps_type>/<int:society_id>/<string:society_key>', methods = ["GET","POST"])
@RouteGroup.society_required
def reference_v1(user_uuid,reference_user_uuid,ps_type,society_id,society_key):
	Auth.checkSocietybyIdKey(society_id,society_key)
	user_reference  = Reference().usp_get_reference_v1(user_uuid,reference_user_uuid)
	userData        = Users().get_user_uuid_data(user_uuid)
	encrypt_user_id = Cryptography.encrypt(int(userData.user_id))
	prefix_name     = userData.prefix+userData.full_name if userData.prefix else userData.full_name   
	if user_reference is None:
		flash("You cannot provide your response, "+prefix_name+" has changed the "+ps_type+".","errorMsg")
		return render_template('memberapp_users/display_msg.html')
	else:
		user = user_reference[0]
		return render_template('memberapp_users/reference_prosec.html',user_id=userData.user_id,reference_by=user['reference_by'],pro=user,encrypt_user_id=encrypt_user_id,society_id=society_id,society_key=society_key)

# Proposer and Seconder accept or reject response sending mail to member 
@app.route('/prosec_accrej_mail/<user_id>/<int:reference_by>/<int:society_id>/<string:society_key>', methods = ["GET","POST"])
@RouteGroup.society_required
def ProsecAccrejMail(user_id,reference_by,society_id,society_key):
	user_id     = unquote(user_id)
	user_id     = int(Cryptography.decrypt(user_id))
	societyData = Auth.getSociety(society_id)
	if societyData:
		userData    = Users().get_member(user_id)
		society     = {
			'society_id'              : society_id,
			'society_key'             : society_key,
			'society_name'            : societyData['society_intial'],
			'support_mail'            : societyData['e_support_mail'],
			'society_full_form'       : societyData['society_title'],
			'society_member_link'     : societyData['society_url'],
			'society_secretary_email' : societyData['e_secretary_mail_id'],
			'backoffice_link'         : societyData['app_host']+ "/bo"
		}
		if request.method == "POST":
			btn         = request.values["reference"]
			if btn == 'Accept':
				data_1         = {'approved_on' : datetime.now(),'updated_at' : datetime.now()}
				Reference().update_prosec_acc_rej(user_id,reference_by,data_1)
				approved_both  = Reference().check_accept_both(user_id)
				count_approved = approved_both[0]
				if int(count_approved == 2):
					ms_sumitted_status_id_json = Helper.getSettings(society_id,'ms_sumitted_status_id_json')
					ms_sumitted_status_id_json_1 = json.loads(ms_sumitted_status_id_json)
					if societyData['member_approve_type']=='before payment':                    
						status  = "approved_both_proposer_seconder_waiting_approval_secretariat_without_pay"
					else:
						status  = "approved_both_proposer_seconder"             
					status_id      = ms_sumitted_status_id_json_1.get(str(userData.status_id),None)
					if status_id:
						data           = {'status_id':status_id,'updated_at': datetime.now()}
						user_logs_data = {'society_id':society_id,'user_id' : user_id,'status_id': status_id,'status':status,'member_type_id':userData.member_type_id,'created_at':datetime.now()}
						UserStatusLogs().insert_status(user_logs_data)
						Users().update_member(user_id,data)
					else:
						pass
					full_name     = userData.prefix+userData.full_name if userData.prefix else userData.full_name
					template_name = "secretary_mail"
					mailDatas     = MembershipMailTemplates().get_mail_template(society_id,template_name)
					sub_datas     = { 'full_name' : full_name }
					sec_subject   = Helper.merge_tags(mailDatas.subject,sub_datas)
					m_datas = {
						'mail_content' : mailDatas.mail_content,
						'userData'     : userData,
						'society'      : society
					}
					mail_content     = Helper.convert_html_for_mail_screen(m_datas)
					email            = societyData['e_secretary_mail_id']
					encrypt_user_id  = Cryptography.encrypt(int(user_id))
					html             = render_template('memberapp_users/email/mail_template.html',mail_content=mail_content,society_id=society_id,society_key=society_key)
					EMAIL.sendMail(sec_subject,html,email,mailDatas,societyData)
					flash("Accepted, Thank you for your response","successMsg")
				else:
					data  = {'updated_at' : datetime.now()}
					Users().update_member(user_id,data)
					flash("Accepted, Thank you for your response","successMsg")
			else:
				data_1  = {'rejected_on' : datetime.now(),'updated_at' : datetime.now()}
				Reference().update_prosec_acc_rej(user_id,reference_by,data_1)
				flash("Rejected, Thank you for your response","errorMsg")
			datas            = Reference().usp_get_reference(user_id,reference_by)
			prosec           = datas[0]
			full_name        = prosec['reference_prefix']+prosec['reference_name'] if prosec['reference_prefix'] else prosec['reference_name']
			template_name    = "response_mail"
			mailData         = MembershipMailTemplates().get_mail_template(society_id,template_name)
			sub_data         = {'full_name'    : full_name,'society_name' : societyData['society_intial']}
			subject          = Helper.merge_tags(mailData.subject,sub_data)
			email            = prosec['user_email']
			encrypt_user_id  = Cryptography.encrypt(int(user_id))
			m_data = {
				'mail_content' : mailData.mail_content,
				'prosec_data'  : prosec,
				'society'      : society
			}
			mail_content     = Helper.convert_html_for_mail_screen(m_data)
			html             = render_template('memberapp_users/email/mail_template.html',mail_content=mail_content,society_id=society_id,society_key=society_key)
			EMAIL.sendMail(subject,html,email,mailData,societyData)
			return redirect(url_for('member.reference_v1',user_uuid=prosec['user_uuid'],reference_user_uuid=prosec['refer_uuid'],ps_type=prosec['type'],society_id=society_id,society_key=society_key))
		else :
			flash("Please, Try again.","errorMsg")
			return redirect(url_for('member.getLogin',society_id=society_id,society_key=society_key))
	else:
		flash("Your session has expired. Please try again.","errorMsg")
		return redirect(url_for('member.getLogin',society_id=society_id,society_key=society_key))

@app.route('/submit_reupdate/<user_id>/<int:society_id>/<string:society_key>',methods=["GET","POST"])
@RouteGroup.login_required
@RouteGroup.society_required
def SubmitReupdate(user_id,society_id,society_key):
	user_id        = unquote(user_id)
	user_id        = int(Cryptography.decrypt(user_id))
	societyData    = Auth.getSociety(society_id)
	status         = "reupdated"
	status_id_1    = MStatus().get_status_id(status,society_id)
	data           = {'status_id':status_id_1.status_id,'updated_at': datetime.now()}
	userData       = Users().get_member(user_id)
	user_logs_data = {'society_id':society_id,'user_id' : user_id,'status_id': status_id_1.status_id,'status':status,'member_type_id':userData.member_type_id,'created_at':datetime.now()}
	UserStatusLogs().insert_status(user_logs_data)
	Users().update_member(user_id,data)
	full_name     = userData.prefix+userData.full_name if userData.prefix else userData.full_name
	template_name = "reupdate_secretary_mail"
	mailDatas     = MembershipMailTemplates().get_mail_template(society_id,template_name)
	sub_datas     = { 'full_name' : full_name }
	sec_subject   = Helper.merge_tags(mailDatas.subject,sub_datas)
	society     = {
						'society_id'              : society_id,
						'society_key'             : society_key,
						'society_name'            : societyData['society_intial'],
						'support_mail'            : societyData['e_support_mail'],
						'society_full_form'       : societyData['society_title'],
						'society_member_link'     : societyData['society_url'],
						'society_secretary_email' : societyData['e_secretary_mail_id'],
						'backoffice_link'         : societyData['app_host']+ "/bo"
					}
	m_datas = {
		'mail_content' : mailDatas.mail_content,
		'userData'     : userData,
		'society'      : society
	}
	mail_content     = Helper.convert_html_for_mail_screen(m_datas)
	email            = societyData['e_secretary_mail_id']
	html             = render_template('memberapp_users/email/mail_template.html',mail_content=mail_content,society_id=society_id,society_key=society_key)
	EMAIL.sendMail(sec_subject,html,email,mailDatas,societyData)
	encrypt_user_id  = Cryptography.encrypt(int(user_id))
	flash("Your application has been resubmitted,  your application shall be auto-forwarded to the secretariat for further process."
			"Typically, it would take 7 working days for processing your application.","successMsg")
	return redirect(url_for('member.Dashboard',user_id=encrypt_user_id,society_id=society_id,society_key=society_key))

@app.route('/memberlist/<int:society_id>/<string:society_key>',methods=["GET","POST"])
@app.route('/memberlist',methods=["GET","POST"])
def Members(society_id=None,society_key=None):
	society = None
	msg     = ""
	if society_id and society_key:
		society = Auth.checkSocietybyIdKey(society_id,society_key)

	if society is None: 
		society      = Society().setSociety(request.host)

	if society:
		society_id  = society['society_id']
	datas = Users().get_member_by_city_district(society_id)
	return render_template('memberapp_users/members_list_for_static.html',datas=datas,society=society,society_id=society_id)

@app.route('/districtlist/<int:society_id>/<string:society_key>',methods=["GET","POST"])
@app.route('/districtlist',methods=["GET","POST"])
def DistrictList(society_id=None,society_key=None):
	society = None
	msg     = ""
	if society_id and society_key:
		society = Auth.checkSocietybyIdKey(society_id,society_key)

	if society is None: 
		society      = Society().setSociety(request.host)
	
	if society:
		society_id  = society['society_id']

	val =1
	datas = Users().usp_district_list(society_id,val)
	for index,value in enumerate(datas) :
		if index == 0 :
			data                     = value   
		if index == 1 :
			total_profile_updated    = value [0]

	
	return render_template('memberapp_users/district_list_for_static.html',datas=data,total=total_profile_updated,society_id=society_id,val=val,societyData=society)

@app.route('/membersdistrict/<int:society_id>/<district>',methods=["GET","POST"])
def MembersDistrict(society_id,district):
	district  = urllib.parse.unquote(district)
	datas     = Users().usp_data_for_district_wise(society_id,district,val=1)
	for index,value in enumerate(datas) :
		if index == 0 :
			districtlist        = value   
	return render_template('memberapp_users/district_list_members.html',datas=districtlist,district=district,society_id=society_id)

@app.route('/profiles_updated/<int:society_id>/<district>/<val>',methods=["GET","POST"])
def ProfilesUpdated(society_id,district,val):
	district = urllib.parse.unquote(district)
	datas    = Users().usp_data_for_district_wise(society_id,district,val)
	for index,value in enumerate(datas) :        
		if index == 1 :
			profilesupdated     = value
	text = "Profile updated"
	return render_template('memberapp_users/district_list_members.html',datas=profilesupdated,district=district,text=text,society_id=society_id)

@app.route('/profiles_not_updated/<int:society_id>/<district>/<val>',methods=["GET","POST"])
def ProfilesNotUpdated(society_id,district,val):
	district = urllib.parse.unquote(district)
	datas    = Users().usp_data_for_district_wise(society_id,district,val)
	for index,value in enumerate(datas) :        
		if index ==2 :
			profilesnotupdated     = value
	text = "Profile not updated"
	return render_template('memberapp_users/district_list_members.html',datas=profilesnotupdated,district=district,text=text,society_id=society_id)

@app.route('/citylist/<int:society_id>/<string:society_key>',methods=["GET","POST"])
@app.route('/citylist',methods=["GET","POST"])
def CityList(society_id=None,society_key=None):
	society = None
	msg     = ""
	if society_id and society_key:
		society = Auth.checkSocietybyIdKey(society_id,society_key)

	if society is None: 
		society      = Society().setSociety(request.host)
	
	if society:
		society_id  = society['society_id']

	val = 2
	datas = Users().usp_district_list(society_id,val)
	for index,value in enumerate(datas) :
		if index == 0 :
			data                     = value   
		if index == 1 :
			total_profile_updated    = value [0]

	
	return render_template('memberapp_users/district_list_for_static.html',datas=data,total=total_profile_updated,society_id=society_id,val=val,societyData=society)

@app.route('/memberscity/<int:society_id>/<city>',methods=["GET","POST"])
def MembersCity(society_id,city):
	city  = urllib.parse.unquote(city)
	val = 2
	datas     = Users().usp_data_for_district_wise(society_id,city,val)
	for index,value in enumerate(datas) :
		if index == 0 :
			districtlist        = value   
			
	return render_template('memberapp_users/district_list_members.html',datas=districtlist,district=city,society_id=society_id)

@app.route('/profiles_updated_city/<int:society_id>/<city>/<val>',methods=["GET","POST"])
def ProfilesUpdatedCity(society_id,city,val):
	city = urllib.parse.unquote(city)
	datas    = Users().usp_data_for_district_wise(society_id,city,val)
	for index,value in enumerate(datas) :        
		if index == 1 :
			profilesupdated     = value
	text = "Profile updated"
	return render_template('memberapp_users/district_list_members.html',datas=profilesupdated,district=city,text=text,society_id=society_id)

@app.route('/profiles_not_updated_city/<int:society_id>/<city>/<val>',methods=["GET","POST"])
def ProfilesNotUpdatedCity(society_id,city,val):
	city = urllib.parse.unquote(city)
	datas    = Users().usp_data_for_district_wise(society_id,city,val)
	for index,value in enumerate(datas) :        
		if index ==2 :
			profilesnotupdated     = value
	text = "Profile not updated"
	return render_template('memberapp_users/district_list_members.html',datas=profilesnotupdated,district=city,text=text,society_id=society_id)


#--------Updated at 22?01?2024-------#
@app.route('/download_id_card/<user_uuid>/<int:society_id>/<string:society_key>',methods=["GET","POST"])
def DownloadIdCard(user_uuid,society_id,society_key):
	user        = Users().get_autologin_data(user_uuid)
	if user:
		user_id     = user['user_id']
		return ViewIdCard(user_id,society_id,society_key)
	else:
		return "Invalid URL"
	

def ViewIdCard(user_id,society_id,society_key):
	societyData    = Society().getSocietybyId(society_id)
	attach_type_id = Helper.AttachTypeId[society_key]
	userData       = Users().get_data_for_idcard(user_id,attach_type_id)
	if userData['attach_path'] and userData['attach_file_name']:
		profile_pic_url = userData['attach_path']+"/"+userData['attach_file_name']
	else:
		profile_pic_url = None

	if int(society_id) == 3:
		url_front = "https://common-application.s3.ap-southeast-1.amazonaws.com/static_asset/id_card/tnoa_idcard_25.jpg"
		url_back = " https://tnoa2022.s3.ap-southeast-1.amazonaws.com/idcard/tnoa_Id_card_back_v1.jpg"

		html =  render_template('memberapp_users/idhtml.html',societyData=societyData,userData=userData,profile_pic_url=profile_pic_url,url_front=url_front,url_back=url_back)
		options = {
			'page-height': '86mm', 
			'page-width': '54mm',
			'margin-top': '0.0in',
			'margin-right': '0.0in',
			'margin-bottom': '0.0in',
			'margin-left': '0.0in',
			"enable-local-file-access": ""
		}
	elif int(society_id) == 17:
		url_front = "https://common-application.s3.ap-southeast-1.amazonaws.com/static_asset/id_card/BOA_idcard_2024.jpg"
		html =  render_template('memberapp_users/idhtml1.html',societyData=societyData,userData=userData,profile_pic_url=profile_pic_url,url_front=url_front)
		options = {
			'page-height': '53.5mm', 
			'page-width': '84mm',
			'margin-top': '0.0in',
			'margin-right': '0.0in',
			'margin-bottom': '0.0in',
			'margin-left': '0.0in',
			"enable-local-file-access": ""
		}
	elif int(society_id) == 2:
		if userData['member_type_id']==1:
			url_front = "https://common-application.s3.ap-southeast-1.amazonaws.com/static_asset/id_card/MOS_id_card_lf_2024.jpg"
		else:
			url_front = "https://common-application.s3.ap-southeast-1.amazonaws.com/static_asset/id_card/MOS_id_card_as_2024.jpg"
		html =  render_template('memberapp_users/idhtml2.html',societyData=societyData,userData=userData,profile_pic_url=profile_pic_url,url_front=url_front)
		options = {
			'page-height': '86mm', 
			'page-width': '54mm',
			'margin-top': '0.0in',
			'margin-right': '0.0in',
			'margin-bottom': '0.0in',
			'margin-left': '0.0in',
			"enable-local-file-access": ""
		}
	else:
		html= None
	
	if is_windows_os == 1:  
		config = pdfkit.configuration(wkhtmltopdf=path_wkhtmltopdf)
	else:
		config = None
		
	if html==None:
		flash("ID Card Not Found","errorMsg")
		return render_template('memberapp_users/display_msg.html')
	else:
		# return html
		return Response(pdfkit.from_string(html, options=options,configuration=config),
				   mimetype="application/pdf",
				   headers={"Content-Disposition":
								"attachment;filename="+str(userData["membership_no"])+"_idcard.pdf"})
	

#------------ updated on 22/01/2024------------#
@app.route('/download_certificate/<user_uuid>/<int:society_id>/<string:society_key>',methods=["GET","POST"])
def DownloadCertificate(user_uuid,society_id,society_key):
	user        = Users().get_autologin_data(user_uuid)
	if user:
		user_id     = user['user_id']
		return ViewCertificate(user_id,society_id,society_key)
	else:
		return "Invalid URL"


def ViewCertificate(user_id,society_id,society_key):
	userData  = Users().get_member(user_id)
	mem_no = userData.membership_no_only
	mem_length = len(str(mem_no))
	today = date.today()
	date1 = today.strftime('%d/%m/%Y')
	if int(society_id) == 3:		
		url_front =     "https://common-application.s3.ap-southeast-1.amazonaws.com/static_asset/id_card/TNOA_life_membership_certificate_25.jpg"
		html =  render_template('memberapp_users/mem_certificate.html',userData=userData,society_id=society_id,url_front=url_front)

		options = {
				'dpi': 300,
				# 'page-size': 'A4',
				'page-height': '105mm', 
				'page-width': '135.5mm',
				'margin-top': '0.0in',
				'margin-right': '0.0in',
				'margin-bottom': '0.0in',
				'margin-left': '0.0in',
				"enable-local-file-access": ""
			}
	elif int(society_id) == 18:
		# url_front =     "https://common-application.s3.ap-southeast-1.amazonaws.com/static_asset/id_card/ksos_life_membership_certificate.jpg"
# 		url_front =     "https://common-application.s3.ap-southeast-1.amazonaws.com/static_asset/id_card/ksos_life_member_certificate_v1.jpg"
		url_front =     "https://common-application.s3.ap-southeast-1.amazonaws.com/static_asset/id_card/ksos_life_member_certificate_v2.jpg"
		html =  render_template('memberapp_users/ksos_mem_certificate.html',userData=userData,society_id=society_id,url_front=url_front,date1=date1,mem_length=mem_length)
		options = {
				'dpi': 300,
				# 'page-size': 'A4',
				'page-height': '97mm', 
				'page-width': '135.5mm',
				'margin-top': '0.0in',
				'margin-right': '0.0in',
				'margin-bottom': '0.0in',
				'margin-left': '0.0in',
				"enable-local-file-access": ""
			}
	else:
		html= None

	if is_windows_os == 1:  
		config = pdfkit.configuration(wkhtmltopdf=path_wkhtmltopdf)
	else:
		config = None

	if html==None:
		flash("Certificate Not Found","errorMsg")
		return render_template('memberapp_users/display_msg.html')
	else:
		# return html
		return Response(pdfkit.from_string(html, options=options,configuration=config),
				   mimetype="application/pdf",
				   headers={"Content-Disposition":
								"attachment;filename="+str(userData.membership_no)+"_certificate.pdf"})
								
#For Members List
@app.route('/members_list/<int:society_id>/<string:society_key>/at/<user_uuid>/<timestamp>', methods = ["GET", "POST"])
def MembersListAutologin(society_id,society_key,user_uuid,timestamp):
	timestamp = round(int(timestamp[:-3]))
	timestamp = datetime.fromtimestamp(int(timestamp))
	if timestamp and (datetime.now() < timestamp):
		userData  = Users().get_autologin_data(user_uuid)
		user_id   = userData['user_id']
		status_id = userData['status_id']
		society_id    = userData['society_id']
		society_key   = userData['society_key']
		if status_id == 14:
			Auth.checkSocietybyIdKey(society_id,society_key)
			bo_access = Users().check_bo_access(userData['email'],1,society_id,None)
			userData["is_admin"] =  bo_access["is_admin"]
			Auth.login(userData,society_id)
			encrypt_user_id  = Cryptography.encrypt(int(user_id))
			return redirect(url_for("member.MembersList",society_id=society_id,society_key=society_key))
		else:
			return redirect(url_for('member.getLogin',society_id=society_id,society_key=society_key))
	else:
		return redirect(url_for('member.getLogin',society_id=society_id,society_key=society_key))


@app.route('/members_list/<int:society_id>/<string:society_key>',methods=["GET","POST"])
@app.route('/members_list',methods=["GET","POST"])
def MembersList(society_id=None,society_key=None):
	society = None
	if society_id and society_key:
		society = Auth.checkSocietybyIdKey(society_id,society_key)

	if society is None: 
		society      = Society().setSociety(request.host)
	status_id            = society['ms_approved_status_id']
	society_intial       = society['society_intial']
	btn_page             = request.values.get('form_submit',None)
	user_id              = None
	search_member_type   = None
	approved_from        = None
	approved_to          = None
	search_name          = request.values.get('search_name',None) or None
	search_email         = request.values.get('search_email',None) or None
	search_mobile        = request.values.get('search_mobile',None) or None
	filter_visible       = request.values.get('filter_visible',None)
	from_memnos          = request.values.get('from_memno',None) or None
	end_memnos           = request.values.get('end_memno',None) or None
	order_type           = request.values.get('order_type',"asc") or None
	sort_by              = request.values.get('sort_by',"membership_no_only") or None

	if from_memnos:
		from_memno = ''.join([i for i in from_memnos if  i.isdigit()])
	else:
		from_memno = None

	if end_memnos:
		end_memno = ''.join([i for i in end_memnos if  i.isdigit()])
	else:
		end_memno = None

	#passing to tempalte for set filter form values
	search_data          = {
		'name'           : search_name,
		'email'          : search_email,
		'mobile'         : search_mobile,
		'from_memno'     : from_memnos,
		'end_memno'      : end_memnos
		
	}
	is_export = False

	if btn_page =="Search" :
		page   = 1
		limit  = 25
		filter_visible = 1
	else:
		page         = int(request.values.get('page',1)) #default page 1
		limit        = int(request.values.get('limit', 25)) 

	offset  = int((page-1)*limit)  
	data    = Users().usp_get_members(search_name,search_email,search_mobile,status_id,offset,limit,user_id,search_member_type,from_memno,end_memno,approved_from,approved_to,society_id,sort_by,order_type)    
	for index,value in enumerate(data) :
		if index == 0:
			if btn_page == "Search" and len(value) == 0 :
				flash("User not found","errorMsg")
				return redirect(url_for('member.MembersList',society_id=society_id,society_key=society_key)) 
			else:
				data = value
		if index == 1 :
			total_count = value[0]
			total       = total_count['count(user_id)']
	numpages = math.ceil(total/limit)
	return render_template('memberapp_users/members_list.html',user_profile=data,offset=offset,page=page,total=int(total),limit=limit,search_data=search_data,filter_visible=filter_visible,society_id=society_id,society_key=society_key,btn_page=btn_page,society_intial=society_intial,numpages=numpages)
	
@app.route('/receipt/<int:society_id>/<string:society_key>',methods = ["GET", "POST"])
def Receipt(society_id,society_key):
	paymentData = Users().get_receipt_data(society_id)
	return render_template('memberapp_users/all_receipt.html',paymentData=paymentData)
	

@app.route('/generate_sqlite',methods = ["GET", "POST"])
def GenerateSqlite():
	societies = Society().session_data_InsertToSqlite_1()
	return "success"

@app.route('/post_file_upload_db/<int:society_id>/<string:society_key>', methods = ["GET","POST"])
@RouteGroup.login_required
@RouteGroup.society_required
def PostFileUploadDB(society_id,society_key):
	if request.method == 'POST':
		user_id         = request.values.get('user_id')
		attach_id       = request.values['attach_id'] 
		attach_type_id  = request.form['attach_type_id']
		societyData     = Auth.getSociety(society_id)
		# s3              = boto3.client("s3",aws_access_key_id='AKIAILLDAQ7NFUMVOYLQ',aws_secret_access_key='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')
# 		files           = request.files.getlist("file")
		file_name = request.values.get('file_name')
# 		for file in files:
		if file_name:
# 			filename        = secure_filename(file_name)
			filename        = file_name
			split_tup       = os.path.splitext(filename)
			file_name       = split_tup[0]
			file_extension  = split_tup[1]
			datas           = MAttachmentType().get_attach_type(attach_type_id)
			attach_type     = datas['attach_type']
			file_str        = attach_type+file_extension
			if " " in file_str :
				file_str = file_str.replace(" ","")
			try:
				bucket     = societyData['aws_bucket']
				user_id    = str(user_id)
				if bucket == 'common-application':
					foldername = str(society_key)+"/user_attachment"
				else:
					foldername = "user_attachment"
				# response   = s3.upload_fileobj(file, bucket,foldername+'/'+user_id+'/'+ file_str, ExtraArgs={"ACL": acl,"ContentType": file.content_type})
				data_1     = {'bucketname' : societyData['aws_bucket'],'foldername':foldername,'file_name':filename+"?"+str(Helper.getcurrenttimestamp()),'msg':'Image successfully uploded','file_extension':file_extension,'status':1} 
				file_path  = societyData['aws_url']+foldername+"/"+user_id

				data = {
					'user_id'           : user_id,
					'attach_type_id'    : attach_type_id,
					'attach_file_name'  : filename,
					'attach_path'       : file_path,
					'created_at'        : datetime.now(),
					'updated_at'        : datetime.now()  
				}
				if (int(attach_id) > 0):
					ua  = UserAttachments().get_user_attach(attach_id,attach_type_id)
					if ua:
						data.pop("created_at") 
						data           = UserAttachments().update_image(attach_id,data)
						d              = {}
						d['attach_id'] = attach_id
						data_1.update(d)
				else :
					attach_id_pk    = UserAttachments().insert_image(data)
					d               = {}
					d['attach_id']  = attach_id_pk
					data_1.update(d)
				return json.dumps(data_1)
			except ClientError as e:
				logging.error(e)
				data_1      = {'msg':'Image upload failed .Please try again.','status':0}        
				json_data   = json.dumps(data_1)
				return json_data
				# flash('Something Error .Please Try Again')
	else :
		flash("Please, Try again.","errorMsg")
		return redirect(url_for('member.getLogin',society_id=society_id,society_key=society_key))

@app.route('/glucoma_fellowship_form/<user_id>/<cur_step>/<pre_step>/<nxt_step>/<int:society_id>/<string:society_key>',methods = ["GET", "POST"])
@RouteGroup.login_required
@RouteGroup.society_required
def GlucomaFellowshipForm(user_id,cur_step,pre_step,nxt_step,society_id,society_key):
	user_id         = unquote(user_id)
	user_id         = int(Cryptography.decrypt(user_id))
	get_user_additional_by_user = UserQualification().get_user_additional_by_user(user_id)
	encrypt_user_id = Cryptography.encrypt(int(user_id))
	return render_template('memberapp_users/glucoma_fellowship_form.html',encrypt_user_id=encrypt_user_id,society_id=society_id,society_key=society_key,cur_step=cur_step,pre_step=pre_step,nxt_step=nxt_step,user=get_user_additional_by_user)


@app.route('/post_glucoma_fellowship_form/<user_id>/<cur_step>/<pre_step>/<nxt_step>/<int:society_id>/<string:society_key>',methods = ["GET", "POST"])
@RouteGroup.society_required
def PostGlucomaFellowshipForm(user_id,cur_step,pre_step,nxt_step,society_id,society_key):
	user_id        = unquote(user_id)
	user_id        = int(Cryptography.decrypt(user_id))
	place          = request.form['place']
	is_life_member = request.form['is_life_member']
	start_date     = request.form['start_date']
	end_date       = request.form['end_date']
	institution    = request.form['institution']
	data = {
		'user_id'                           : user_id,
		'is_any_fellowship'					: is_life_member,
		'any_fellowship_place_training'     : place,
		'fellowship_start_date'         	: start_date,
		'fellowship_end_date'      			: end_date,
		'institution'       				: institution,
		'created_at'        				: datetime.now(),
		'updated_at'        				: datetime.now(),
		}
	update_or_insert = UserQualification().update_or_insert_user_additional(user_id,data) 
	encrypt_user_id  = Cryptography.encrypt(int(user_id))
	return redirect (url_for('member.getStep',user_id=encrypt_user_id,step_no=nxt_step,society_id=society_id,society_key=society_key))


@app.route('/type_of_practice/<user_id>/<cur_step>/<pre_step>/<nxt_step>/<int:society_id>/<string:society_key>',methods = ["GET", "POST"])
@RouteGroup.login_required
@RouteGroup.society_required
def TypeOfPractice(user_id,cur_step,pre_step,nxt_step,society_id,society_key):
	user_id         = unquote(user_id)
	user_id         = int(Cryptography.decrypt(user_id))
	user = Users().get_member(user_id)
	encrypt_user_id = Cryptography.encrypt(int(user_id))
	return render_template('memberapp_users/type_of_practice.html',encrypt_user_id=encrypt_user_id,user=user,society_id=society_id,society_key=society_key,user_id=user_id,cur_step=cur_step,pre_step=pre_step,nxt_step=nxt_step)


@app.route('/post_type_of_practice/<user_id>/<cur_step>/<pre_step>/<nxt_step>/<int:society_id>/<string:society_key>',methods = ["GET", "POST"])
@RouteGroup.society_required
def PostTypeOfPractice(user_id,cur_step,pre_step,nxt_step,society_id,society_key):
	user_id         		= unquote(user_id)
	user_id         		= int(Cryptography.decrypt(user_id))
	type_of_practice        = request.form.getlist('type_of_practice')
	practice_percentage     = request.form.getlist('practice_percentage')
	type_of_practice_str    = ', '.join(type_of_practice)  # Example for comma-separated
	practice_percentage_str = ', '.join(practice_percentage)
	data = {
			'type_of_practice'    : type_of_practice_str,
			'practice_consists_percentage' : practice_percentage_str
	}
	Users().update_member(user_id,data)
	encrypt_user_id  = Cryptography.encrypt(int(user_id))
	return redirect (url_for('member.getStep',user_id=encrypt_user_id,step_no=nxt_step,society_id=society_id,society_key=society_key))