from calendar import month_name
from fileinput import filename
from os import listdir
from os.path import join, dirname, realpath
from sqlalchemy import null
from werkzeug.utils import secure_filename
import os
from flask import Flask, request, Blueprint, jsonify, redirect, url_for,flash, render_template,session,json
import datetime
from datetime import timedelta,date,datetime
from flask import session, app
from .. import Cryptography,Auth,RouteGroup,Helper
from core.model.Users import Users
from core.model.Society import Society
from core.model.MMemberType import MMemberType
from core.model.MembershipMailTemplates import MembershipMailTemplates
from core.library.email import EMAIL
import boto3, botocore
from botocore.exceptions import ClientError
import logging
from urllib.parse import unquote



app = Blueprint('usermail', __name__)


@app.route('/usermail/<society_id>/<society_key>',methods = ["GET", "POST"])
def UserMail(society_id,society_key):
	if society_id and society_key:
		societyData = Auth.checkSocietybyIdKey(society_id,society_key)
	status_id   		 = societyData['ms_approved_status_id']
	btn_page        	 = request.values.get('form_submit',None)
	search_name 		 = request.values.get('search_name',None) or None
	search_email		 = request.values.get('search_email',None) or None
	search_mobile		 = request.values.get('search_mobile',None) or None
	search_member_type 	 = request.values.get('search_member_type',None) or None
	filter_visible  	 = request.values.get('filter_visible',None)
	from_memnos 		 = request.values.get('from_memno',None) or None
	end_memnos 			 = request.values.get('end_memno',None) or None
	approved_from        = request.values.get('approved_from',None) or None
	approved_to          = request.values.get('approved_to',None) or None
	order_type           = request.values.get('order_type',"asc") or None
	sort_by              = request.values.get('sort_by',"membership_no_only") or None

	if from_memnos:
		from_memno = ''.join([i for i in from_memnos if  i.isdigit()])
	else:
		from_memno = None

	if end_memnos:
		end_memno = ''.join([i for i in end_memnos if  i.isdigit()])
	else:
		end_memno = None

	#passing to tempalte for set filter form values
	search_data     	 = {
		'name'			 : search_name,
		'email'			 : search_email,
		'mobile'    	 : search_mobile,
		'member_type'	 : search_member_type,
		'from_memno'     : from_memnos,
		'end_memno'		 : end_memnos,
		'approved_from'  : approved_from,
		'approved_to'    : approved_to,
		'order_type'     : order_type,
		'sort_by'        : sort_by
	}
	is_export = False

	if btn_page =="Search" :
		page   = 1
		limit  = 50000
		filter_visible = 1
	
	else:
		page         = int(request.values.get('page',1)) #default page 1
		limit        = int(request.values.get('limit', 50000)) 

	offset  = int((page-1)*limit)  
	data    = Users().usp_get_members(search_name,search_email,search_mobile,status_id,offset,limit,None,search_member_type,from_memno,end_memno,approved_from,approved_to,society_id,sort_by,order_type)	
	for index,value in enumerate(data) :
		if index == 0:
			if btn_page == "Search" and len(value) == 0 :
				flash("User not found","errorMsg")
				return redirect(url_for('usermail.UserMail',society_id=society_id,society_key=society_key))
			elif len(value) == 0:
				flash("There is no members for  membership approved list","errorMsg")
				return redirect(url_for('usermail.UserMail',society_id=society_id,society_key=society_key))
			else:
				data = value
		if index == 1 :
			total_count = value[0]
			total       = total_count['count(user_id)']

	member_types = MMemberType().get_member_type_approved(society_id)
	return render_template('bulk_mail/members_list_for_bulkmail.html',datas=data,society=societyData,society_id=society_id,society_key=society_key,member_types=member_types,search_data=search_data,filter_visible=filter_visible)



# For sending mail in report page
@app.route('/send_bulkmail/<society_id>/<society_key>',methods=["GET","POST"])
def ReportSendMail(society_id,society_key):
	society = Auth.checkSocietybyIdKey(society_id,society_key)
	template_name   = "profile_confirmation_mail_for_yesno"
	mailData        = MembershipMailTemplates().get_mail_template(society_id,template_name)
	is_test         = request.values.get('is_test')
	test_mail       = request.values.get('test_mail_id')
	user_ids        = request.values.get('selected_user_ids',None)
	user_ids_lst    = user_ids.split(',') if user_ids else None
	data		    = Users().usp_user_all_data_v1(user_ids,society_id) # searching members	

	for index,value in enumerate(data):
		if index == 0:
			datas = value

			userData_lst = {} 
			for userData in datas:
				userData_lst[userData['user_id']] = userData

			for user_id in user_ids_lst:
				userData = userData_lst.get(int(user_id),None)

				sub_data      = {'prefix':userData['prefix'],'full_name':userData['full_name'],'society_intial':society['society_intial']}
				subject       = Helper.merge_tags(mailData['subject'],sub_data)
				mail_data = {
					'mail_content': mailData['mail_content'],
					'userData'     : userData,
					'societyData' : society
					}
				email = userData['email']
				mail_content  = Helper.convert_html_for_mail_screen(mail_data)
				html             = render_template('bulk_mail/confirmation_mail.html',mail_content=mail_content,societyData=society,society_id=society_id,society_key=society_key)
				
				if int(is_test) == 1:
					msg  = 'Test Mail sent successfully'
					EMAIL.sendMail_v1(subject,html,test_mail,mailData,society)
				else:
					msg  = 'Mail sent successfully'
					EMAIL.sendMail_v1(subject,html,email,mailData,society)
				data = {'msg':msg}

	return jsonify(data)
	
@app.route('/proofmail/<society_id>/<society_key>',methods = ["GET", "POST"])
def ProofMail(society_id,society_key):
	if society_id and society_key:
		society = Auth.checkSocietybyIdKey(society_id,society_key)
	datas = Users().get_member_by_notproof(society_id)
	return render_template('bulk_mail/members_list_for_bulkmail.html',datas=datas,society=society,society_id=society_id,society_key=society_key)
	