from core import app
from flask import render_template_string
from flask import url_for,render_template,request,redirect,session
from datetime import datetime, date, time, timedelta
import datetime
import math,random
import time
from core.model.SocietyAssets import SocietyAssets
from core.model.MSSetting import MSSetting
from requests.utils import requote_uri
import requests

class Helper:
	
	AppType 			 = "MEMBERSHIP"
	AiosMembershipNumber = ['vrsi','mos','tnoa','mcoa','ros']
	AadhaarNumber        = ['tnoa']
	AadhaarAddress       = ['tnoa']
	ColumnDescription    = ['vrsi','mos','tnoa','ipgs','csos','apots']
	HospitalAddress      = {'iages':{'show':1,'req':1}}
	AttachTypeId         = {'vrsi':7,'mos':1,'tnoa':12, 'ipgs':16, 'apots':17, 'csos':23,'ksos':45,'kos' : 52, 'demo':29,'mcoa':56,'boa':44,'ros':70,'yosi':74,'gsi':80}
	gov_proof_type       = ['Aadhar Card','PAN card','Passport','Driving Licence','Ration card','Govt Issued Employee ID']
	type_of_practice     = ['Institutional Practice','Private Practice','Government Service','Corporate Hospital','NGO','Combined','Others']
	practice_percentage  = ['No Glaucoma','Less than 1/3rd','Less than 50%','More than 50%','Only Glaucoma Patients']
	AttachType           = 'Photograph'
	AssociateMemberId    = 6
	ExpiredMemberId      = 10
	LifeMemberId		 = 1
	NationalMemberId	 = 17
	kos_tarrif           = 4000
	FellowshipAttachId1   = {'vrsi' :11, 'ksos' :50, 'demo' :51}
	FellowshipAttachId2   = {'ksos':68}
	
	def date_diff(d1, d2):
		# fmt	= '%H:%M'
		d1		=	date(d1,'%Y, %m, %d')
		d2		=	date(d2,'%Y, %m, %d')   		
		diff	=	str(d1) - str(d2)		
		return diff

	def random_otp():
		digits      = "123456789"
		otp_random  = ""
		for i in range(4) :
			random.seed(time.process_time())
			otp_random += digits[math.floor(random.random() * 9)]
		return otp_random

	def getcurrenttimestamp():
		ct = datetime.datetime.now()
		ts = ct.timestamp()
		return ts 
		
	def email_mask(email):
		if email:
			lo = email.find('@')
			if lo>0:
				mask_email =  email[0]+"*****"+email[lo-1:]
				return mask_email
		return email      

	def mobile_mask(mobile):
		if mobile:
			lo = len(mobile)
			if lo>0:
				mask =  mobile[:2]+"******"+mobile[lo-2:]
			return mask
		return mobile  

	def convert_html_for_payment_screen(payment_content,member):
		temp = app.jinja_env.from_string("{{payment_content.payment_content|safe}}").render(payment_content=payment_content,member=member)
		return render_template_string(temp,payment_content=payment_content,member=member)

	# def convert_html_for_mail_screen(mail_content,userData,qul_data,exp_data,image,prosec_data,society):
	# 	temp = app.jinja_env.from_string("{{mail_content|safe}}").render(mail_content=mail_content,userData=userData,qul_data=qul_data,exp_data=exp_data,image=image,prosec_data=prosec_data,society=society)
	# 	return render_template_string(temp,mail_content=mail_content,userData=userData,qul_data=qul_data,exp_data=exp_data,image=image,prosec_data=prosec_data,society=society)

	def convert_html_for_mail_screen(data):
		temp = app.jinja_env.from_string("{{mail_content|safe}}").render(**data)
		return render_template_string(temp,**data)
	

	def merge_tags(text,values):
		for k, v in values.items():
			text = text.replace('*|'+k+'|*', v)
		return text

	def pagination_tool(total,page,limit):
		numpages = math.ceil(total/limit)
		return render_template('back_office/pagination.html',total=total,limit=limit,page=page,numpages=numpages)

	def base_url():
		base_url         = request.host_url
		if "https" in base_url :
			pass
		else :
			base_url = base_url.replace("http" ,"https")
			return base_url

	def sendWhatsApp(mobile,wp_content):
		wp_content = requote_uri(wp_content)
		h_link = "http://wa.me/91"+mobile+"?text="+wp_content
		return h_link

	def getSoceityAssets(society_id,asset_name):
		assets_dict = session.get('asset_'+str(society_id),None) # check asset data from session 
		if assets_dict is None: # if session data not the get from database and set in session 
			assetsData = SocietyAssets().getsociety_assets(society_id)
			assets_dict = {}
			for ad in assetsData:
				assets_dict[ad['asset_name']] = ad['asset_url']
			session['asset_'+str(society_id)] = assets_dict # set asset_dict to session 
		return assets_dict[asset_name]
	
	def getSettings(society_id,setting_key):
		setting_dict = session.get('setting_'+str(society_id),None)
		if setting_dict is None:
			settingData  = MSSetting().get_settings(society_id)
			if settingData : 
				setting_dict = {}	
				for setting in settingData:
					setting_dict[setting['setting_key']] = setting['setting_value']
				session['setting_'+str(society_id)] = setting_dict 
			else:
				return None
		return setting_dict.get(setting_key,None)
		
	def dt_compere_greaterthen(str_dt1, str_dt2):
		try:
			if str_dt1 >=  str_dt2:
				return True;
			else:
				return False;
			return date_obj
		except Exception:
			return False
		
		
	def google_recaptcha_api_siteverify(recaptcha_response):
		try:
			# Verify the reCAPTCHA response with Google's server
			url = "https://www.google.com/recaptcha/api/siteverify"
			data = {
				'secret': "6LdXVLkqAAAAAFTyUOTIvA0UE6YuyQd3MBtNGx3T",
				'response': recaptcha_response
			}
			response = requests.post(url, data=data)
			result = response.json()
			
			if result.get('success'):
				return 1,"reCAPTCHA verification successfully!"
			else:
				return 0,"reCAPTCHA verification failed. Please try again."
		except Exception:
			return 0,"Internal Error"
		

app.jinja_env.globals.update(Helper=Helper)	




