from sqlalchemy import create_engine, MetaData, Table, insert, select,update,delete,text
from sqlalchemy.sql import and_, or_
from core import app
import json
from .. import engine

# engine = create_engine(app.config['DATABASE_URI'],pool_size=5000,pool_pre_ping=True,pool_recycle=3600)
# engine = create_engine(app.config['DATABASE_URI'],pool_size=5000,max_overflow=100,pool_pre_ping=True,pool_recycle=3600)
# engine = create_engine(app.config['DATABASE_URI'], poolclass=None,pool_size=5000,max_overflow=100,pool_pre_ping=True,pool_recycle=3600)

class MembershipMailTemplates():
	def __init__(self):
		try:
			self.meta = MetaData()
			self.mail_templates        = Table("mail_templates", self.meta, autoload_with=engine)
		   
		except Exception as e:
			print(e)

	def get_mail_template(self,society_id,template_name):
		with engine.connect() as conn:
			stmt = text("select * from mail_templates where society_id=:society_id and template_name=:template_name and is_active =1;")
			results = conn.execute(stmt.bindparams(society_id=society_id,template_name=template_name))
			results=  results.first()
			conn.close()
			if results :
				return results._mapping
			else:
				return None

	def get_mail_template_name(self,society_id):
		with engine.connect() as conn:
			stmt = text("select * from mail_templates where society_id=:society_id and  is_active =1 and app_type_id=1;")
			results = conn.execute(stmt.bindparams(society_id=society_id)).all()
			results=  [dict(r.__mapping) for r in results] if results else None
			conn.close()
			if results :
				return results
			else:
				return None  

	def get_mail_template_preview(self,society_id,mail_template_id):
		with engine.connect() as conn:
			stmt = text("select * from mail_templates where society_id=:society_id and mail_template_id=:mail_template_id and is_active =1;")
			results = conn.execute(stmt.bindparams(society_id=society_id,mail_template_id=mail_template_id))
			results=  results.first()
			conn.close()
			if results :
				return dict(results._mapping)
			else:
				return None